c   Behrens Fisher Problem
c   Test of H_0: Pr{X > Y}=.5
c
c   Application Program
c   Change from bf.semi.f :  Semiparametric Method of Fokianos added
c
c           James F. Troendle
c                3-2005
c   
      program bfapp
      common data(4000),m(4000),mprime(4000),n1,n2,psum(0:4000)
      common nprime,posval(4000),lambda,lambd2
      real x(2000),y(2000),data,lam1,psum0(4000),qsum0(4000)
      real p(4000),q(4000),xguess(1),inc,data0(4000)
      real sol(1),lrt,rn(2000),xstar(2000),ystar(2000)
      real lam1min,lam1m2,lam1m3,mu1,mu2,mr1,mr2,lam1bar,lam2bar
      real midrank(4000),xmidrank(4000),ymidrank(4000),lammin
      real lrt1sim,lrt2sim,min,values(4000),lambda,lamhat
      real lambd2,lam1hat,lam2hat,alphat,p2hat(4000),theta2h(4000)
      real phat(4000),thetahat(4000),lammax,h(4000),h1(4000),h2(4000)
      real yy(4000),w(4000),kappa(4000),lam2max
      real delta(3,1),cov(3,3),cc(1,3),ainv(3,3)
      real sem1sim(999999),sem2psim(999999)
      real sem2sim(999999),sem22sim(999999)
      double precision  x0(3),xscale(3),rparam(7),xsol(3),ccc(3,3)
      double precision fscale,fvalue,likmax,a(3,3),dainv(3,3)
      integer iparam(7)
      integer yrank(4000),xrank(4000),info(1)
      integer dist1,dist2,msave(4000)
      integer m,mprime,samcount(4001)
      integer irn(2000),xsamc,ysamc
      character*80 infile
      external fcn,loglike,grad,log2like,grad2

c  Input parameters
      open(9,file='/home/troendlj/fortran/nonpar/bf.semi.param')
c
c  infile is the input data set
c      infile=
c     *'/home/troendlj/fortran/nonpar/chenkianifarddata.txt'
      read(9,*) infile
c  nsim=number of simulations used to approx. null dist. (<= 999999)
c      nsim=199999
      read(9,*) nsim
c  iseed is random seed initializer
c      iseed=27623661
      read(9,*) iseed
c  tol is tolerence for solution
      tol=.01
c  srchmul is multiple of sample size that defines radius of search region for lambda_1
      srchmul=2.0
c  lammax is search radius for lambda, the Box-Cox transform power
      lammax=1.0
      lam2max=2.0
      lammin=0.0
c  Indicators of tests to include (1=include, 0=exclude)
      testperm=0.0
      testsim=1.0
      testlrt=1.0
      test1d=1.0
      test2d=1.0

      close(9)

      call erset(3,0,0)
      call erset(4,0,0)
      call rnset(iseed)
c      i=ieee_handler('set','invalid',sigfpe_abort)


      nflag=0

c   Read in the Data
      open(10,file=infile)
      read(10,*) n1
      do 20 i=1,n1
        read(10,*) x(i)
   20 continue
      read(10,*) n2
      do 30 i=1,n2
        read(10,*) y(i)
   30 continue
      close(10)

c      write(6,*) 'x values= ',(x(i),i=1,n1)
c      write(6,*) 'y values= ',(y(i),i=1,n2)
c
c  values holds the actual values for permutation sampling 
c
      min=x(1)
      do 51 i=1,n1
        values(i)=x(i)
        if (x(i) .lt. min) min=x(i)
   51 continue  
      do 52 i=1,n2
        values(n1+i)=y(i)
        if (y(i) .lt. min) min=y(i)
   52 continue  
c
c  posval holds the shifted (positive) values for Box-Cox transform
c    new minimum set to .5
c
      do 53 i=1,n1+n2
        posval(i)=values(i)-min+.5
   53 continue  
c
c  Welch t-test with approximate dof
c
      xbar=0.0
      do 55 i=1,n1
        xbar=xbar+x(i)
   55 continue
      xbar=xbar/real(n1)
      ybar=0.0
      do 56 i=1,n2
        ybar=ybar+y(i)
   56 continue
      ybar=ybar/real(n2)
      s1=0.0
      do 57 i=1,n1
        s1=s1+(x(i)-xbar)**2
   57 continue
      s1=s1/real(n1-1)
      s2=0.0
      do 58 i=1,n2
        s2=s2+(y(i)-ybar)**2
   58 continue
      s2=s2/real(n2-1)
      sd=s1/real(n1)+s2/real(n2)
      
      twel=(ybar-xbar)/sqrt(sd)
 
      temp=s1/(real(n1)*sd)
      dof=temp**2/real(n1-1)+(1.-temp**2)/real(n2-1)
      dof=1./dof
c
c  Null distribution of Welch is t with dof degrees of freedom
c
      pow3wel=2.*(1.-tdf(abs(twel),dof))
c
c  Order y values among themselves
c
c  n2prime=number of distinct y values
c  mprime(i) is the multiplicity of value y_(i)
c
      do 75 i=1,n2
        do 70 j=i+1,n2
          if (y(j) .lt. y(i)) then
            temp=y(i)
            y(i)=y(j)
            y(j)=temp
          endif
   70   continue
   75 continue
      n2prime=1
      mprime(1)=1
      i=2
      icount=0
   77 continue
      if (y(i) .eq. y(n2prime)) then 
        mprime(n2prime)=mprime(n2prime)+1
        icount=icount+1
        do 78 j=i,n2-1
          y(j)=y(j+1)
   78   continue
      else
        n2prime=n2prime+1
        mprime(n2prime)=1
        i=i+1
      endif
      if (i .lt. n2-icount+1) go to 77
c
c  Order x values among themselves
c
c  n1prime=number of distinct x values
c  m(i) is the multiplicity of value x_(i)
c
      do 90 i=1,n1
        do 80 j=i+1,n1
          if (x(j) .lt. x(i)) then
            temp=x(i)
            x(i)=x(j)
            x(j)=temp
          endif
   80   continue
   90 continue
      n1prime=1
      m(1)=1
      i=2
      icount=0
   92 continue
      if (x(i) .eq. x(n1prime)) then 
        m(n1prime)=m(n1prime)+1
        icount=icount+1
        do 93 j=i,n1-1
          x(j)=x(j+1)
   93   continue
      else
        n1prime=n1prime+1
        m(n1prime)=1
        i=i+1
      endif
      if (i .lt. n1-icount+1) go to 92

c      write(6,*) 'x values= ',(x(i),i=1,n1prime)
c      write(6,*) 'x multiplicities= ',(m(i),i=1,n1prime)
c      write(6,*) 'y values= ',(y(i),i=1,n2prime)
c      write(6,*) 'y multiplicities= ',(mprime(i),i=1,n2prime)
c
c  Set up data to hold combined data
c  Set up xrank to hold the order statistic number if the corresponding entry of data() is a x value
c  Set up yrank to hold the order statistic number if the corresponding entry of data() is a y value
c
      do 110 i=1,n1prime
        data(i)=x(i)
        yrank(i)=0
        xrank(i)=i
  110 continue
      do 115 i=1,n2prime
        msave(i)=mprime(i)
  115 continue
      do 120 i=1,n2prime
        data(n1prime+i)=y(i)
        yrank(n1prime+i)=i
        xrank(n1prime+i)=0
        m(n1prime+i)=0
        mprime(n1prime+i)=msave(i)
  120 continue
      do 125 i=1,n1prime
        mprime(i)=0
  125 continue
c
c  Order the combined values
c
      do 150 i=1,n1prime+n2prime-1
        do 140 j=i+1,n1prime+n2prime
          if (data(j) .lt. data(i)) then
            temp=data(i)
            temp2=xrank(i)
            temp3=yrank(i)
            temp4=m(i)
            temp5=mprime(i)
            data(i)=data(j)
            xrank(i)=xrank(j)
            yrank(i)=yrank(j)
            m(i)=m(j)
            mprime(i)=mprime(j)
            data(j)=temp
            xrank(j)=temp2
            yrank(j)=temp3
            m(j)=temp4
            mprime(j)=temp5
          endif
  140   continue
  150 continue
c      write(6,*) 'data values= ',(data(i),i=1,n1prime+n2prime)
c      write(6,*) 'x multiplicities= ',(m(i),i=1,n1prime+n2prime)
c      write(6,*) 'y multiplicities= ',(mprime(i),i=1,n1prime+n2prime)
c
c  Set up samcount(i) to give the combined ordered sample less than data(i)
c
      sumyr0=0.
      samcount(1)=0
      ysamc=0
      xsamc=0
      do 170 i=1,n1prime+n2prime
        if (yrank(i) .ne. 0) then
          midrank(i)=0.0
          do 160 j=samcount(i)+1,samcount(i)+mprime(i)
            midrank(i)=midrank(i)+real(j)
  160     continue
          ymidrank(i)=0.0
          do 161 j=ysamc+1,ysamc+mprime(i)
            ymidrank(i)=ymidrank(i)+real(j)
  161     continue
          ymidrank(i)=ymidrank(i)/real(mprime(i))
          ysamc=ysamc+mprime(i)
          midden=mprime(i)
          if (i .ne. 1) then
            if (data(i) .eq. data(i-1)) then
              do 162 j=samcount(i-1)+1,samcount(i-1)+m(i-1)
                midrank(i)=midrank(i)+real(j)
  162         continue
              midden=midden+m(i-1)
            endif
          endif
          midrank(i)=midrank(i)/real(midden)
          samcount(i+1)=samcount(i)+mprime(i)
          sumyr0=sumyr0+midrank(i)*real(mprime(i))
        endif
        if (xrank(i) .ne. 0) then
          midrank(i)=0.0
          do 165 j=samcount(i)+1,samcount(i)+m(i)
            midrank(i)=midrank(i)+real(j)
  165     continue
          xmidrank(i)=0.0
          do 166 j=xsamc+1,xsamc+m(i)
            xmidrank(i)=xmidrank(i)+real(j)
  166     continue
          xmidrank(i)=xmidrank(i)/real(m(i))
          xsamc=xsamc+m(i)
          midden=m(i)
          samcount(i+1)=samcount(i)+m(i)
          if (i .ne. n1prime+n2prime) then
            if (data(i) .eq. data(i+1)) then
              do 167 j=samcount(i+1)+1,samcount(i+1)+mprime(i+1)
                midrank(i)=midrank(i)+real(j)
  167         continue
              midden=midden+mprime(i+1)
            endif
          endif
          midrank(i)=midrank(i)/real(midden)
        endif
  170 continue
c      write(6,*) 'midrank= ',(midrank(i),i=1,n1prime+n2prime)
c      write(6,*) 'Obs. sumyrank= ',sumyr0
c      write(6,*) 'xmidrank=',(xmidrank(i),i=1,n1prime+n2prime)
c      write(6,*) 'ymidrank=',(ymidrank(i),i=1,n1prime+n2prime)
c
c  Wilcoxon Rank Test using Large Sample Theory
c
      wilco0=sumyr0-.5*real(n2)*real(n1+n2+1)
      wilco0=wilco0*sqrt(12.)/sqrt(real(n1*n2)*real(n1+n2+1))
      pow3wil=2.*(1.-anordf(abs(wilco0)))

c
c  Reduce to distinct values
c
      nprime=1
      max=n1prime+n2prime
      i=2
  172 continue
      if (data(i) .eq. data(i-1)) then
        mprime(i-1)=mprime(i)
        ymidrank(i-1)=ymidrank(i) 
        do 175 j=i,max-1 
          data(j)=data(j+1)
          midrank(j)=midrank(j+1) 
          m(j)=m(j+1) 
          mprime(j)=mprime(j+1) 
          ymidrank(j)=ymidrank(j+1) 
          xmidrank(j)=xmidrank(j+1) 
  175   continue
        max=max-1
      else
       nprime=nprime+1
       i=i+1
      endif   
      if (i .le. max) go to 172

c      write(6,*) 'distinct data values= ',(data(i),i=1,nprime)
c      write(6,*) 'x multiplicities= ',(m(i),i=1,nprime)
c      write(6,*) 'y multiplicities= ',(mprime(i),i=1,nprime)
c      write(6,*) 'midrank= ',(midrank(i),i=1,nprime)
c      write(6,*) 'xmidrank=',(xmidrank(i),i=1,nprime)
c      write(6,*) 'ymidrank=',(ymidrank(i),i=1,nprime)

c
c
c=========================================================
c
c  Brunner (2000) test based on estimation of treatment effect, p
c
c  Find mean rank of X's in combined sample
c  Find mean rank of Y's in combined sample
c
      mr1=0.
      mr2=0.
      do 210 i=1,nprime
        mr1=mr1+midrank(i)*real(m(i))
        mr2=mr2+midrank(i)*real(mprime(i))
  210 continue
      mr1=mr1/real(n1)
      mr2=mr2/real(n2)
c      write(6,*) 'Nonparametric est of p is ',(mr1-mr2)/real(n1+n2)+.5
c      write(6,*) 'mean x rank= ',mr1
c      write(6,*) 'mean y rank= ',mr2
c
c
c  Calculate s1^2 and s2^2
      s1sq=0.
      s2sq=0.
      do 220 i=1,nprime
        s1sq=s1sq+(midrank(i)-xmidrank(i)-mr1+real(n1+1)/2.)**2*m(i)
        s2sq=s2sq+(midrank(i)-ymidrank(i)-mr2+real(n2+1)/2.)**2
     *           *mprime(i)
  220 continue
      s1sq=s1sq/real(n1-1)
      s2sq=s2sq/real(n2-1)
c      write(6,*) 's1sq= ',s1sq
c      write(6,*) 's2sq= ',s2sq


c
c  Calculate WBF, the test statistic
c
      if (s1sq+s2sq .ne. 0.0) then
        wbf=(mr2-mr1)/(real(n1+n2)*sqrt(s1sq/real(n1*n2**2)+s2sq/
     *       real(n2*n1**2)))
      else
        wbf=99999.
      endif 

c      write(6,*) 'wbf= ',wbf
c
c  Null distribution of WBF is t with ff dof
c
      ff=(s1sq/real(n2)+s2sq/real(n1))**2
      ff=ff/(s1sq**2/real(n2**2*(n1-1))+
     *        s2sq**2/real(n1**2*(n2-1)))
c
c  Use approximate t_ff null distribution to test H_0
c
c      if (abs(wbf) .gt. tin(1.-sig/2.,ff)) br3rej=br3rej+1
      pow3br=2.*(1.-tdf(abs(wbf),ff))
c
c=========================================================
c  SEMIPARAMETRIC MAXIMUM LIKELIHOOD (Both 1 and 2 DIM Models)
c  To skip 1-DIM Model
      if (test1d .eq. 0.0) go to 251

      fscale=1.d0
      xscale(1)=1.d0
      xscale(2)=1.d0
      x0(1)=0.d0
      x0(2)=0.d0

c      write(6,*) 'pos values= ',(posval(i),i=1,n1+n2)

c
c  Maximize over lambda from -lammax to lammax
c
c  1-dim Model
c
      mm=int(5*(lammax-lammin))+1
      likmax=-9.d99
      do 250 l=1,mm
        lambda=lammin+.2*real(l-1)
        if (abs(lambda) .le. 0.001) lambda=0.0
  
c        lambda=1.

c        write(6,*) 'Start UMING to maximize log(likelihood)'
        call du4inf(iparam,rparam)
        rparam(5)=.001
        call duming(loglike,grad,2,x0,xscale,fscale,iparam,rparam,
     *              xsol,fvalue)

c        write(6,*) 'Solution is (lambda,alpha,beta)'
c        write(6,*) '(',lambda,',',xsol(1),',',xsol(2),')'
c        write(6,*) 'With log(likelihood)=',-1.*fvalue
         if (-1.*fvalue .gt. likmax) then
           likmax=-1.*fvalue
           lamhat=lambda
           alphahat=xsol(1)
           betahat=xsol(2)
         endif

  250 continue
  251 continue
      write(6,*) '1-DIM Solution is (lamhat,alphahat,betahat)'
      write(6,*) '(',lamhat,',',alphahat,',',betahat,')'
      write(6,*) 'With log(likelihood)=',likmax
      avglam=avglam+lamhat
c      write(6,*) lamhat
c-----------------------------
c  2-dim Model
c
c  To skip 2-DIM Model
      if (test2d .eq. 0.0) go to 256

      fscale=1.d0
      xscale(1)=1.d0
      xscale(2)=1.d0
      xscale(3)=1.d0
      x0(1)=0.d0
      x0(2)=0.d0
      x0(3)=0.d0

c
c  Maximize over lambda from -lammax to lammax
c
      mm=int(5*(lammax-lammin))+1
      likmax=-9.d99
      do 255 l=1,mm
        lambda=lammin+.2*real(l-1)
        if (abs(lambda) .le. 0.001) lambda=0.0
        do 252 ll=1,mm-1
          lambd2=lammax+.2*real(ll)
          if (abs(lambd2) .le. 0.001) lambd2=0.0
  
c          lambda=1.
c          lambd2=2.

c          write(6,*) 'lambda=',lambda
c          write(6,*) 'lambd2=',lambd2
c          write(6,*) 'Start UMING to maximize log(likelihood)'
          call du4inf(iparam,rparam)
          rparam(5)=.001
          call duming(log2like,grad2,3,x0,xscale,fscale,iparam,rparam,
     *              xsol,fvalue)

c          write(6,*) 'Solution is (lambda1,lambda2,alpha,beta1,beta2)'
c          write(6,*) '(',lambda,',',lambd2,',',xsol(1),',',xsol(2),
c     *                ',',xsol(3),')'
c          write(6,*) 'With log(likelihood)=',-1.*fvalue
          if (-1.*fvalue .gt. likmax) then
            likmax=-1.*fvalue
            lam1hat=lambda
            lam2hat=lambd2
            alphat=xsol(1)
            beta1hat=xsol(2)
            beta2hat=xsol(3)
          endif
  252   continue
  255 continue
  256 continue
      write(6,*) '2-DIM Global Sol. is (lam1,lam2,alpha,beta1,beta2)'
      write(6,*) '(',lam1hat,',',lam2hat,',',alphat,',',beta1hat,
     *             ',',beta2hat,')'
      write(6,*) 'With log(likelihood)=',likmax
      write(6,*) '-------------------------------------------------'
      lam1bar=lam1bar+lam1hat
      lam2bar=lam2bar+lam2hat

c
c   Calculate phat, the discrete elements of underlying distribution
c   1-dim Model
c
      do 260 i=1,n1+n2
        if (lamhat .eq. 0.0) then
          h(i)=log(posval(i))
          zz=alphahat+betahat*log(posval(i))
        else
          h(i)=(posval(i)**(lamhat)-1.)/lamhat
          zz=alphahat+betahat*(posval(i)**(lamhat)-1.)/lamhat
        endif
        if (zz .lt. 18.42) then
          thetahat(i)=exp(zz)
        else
          thetahat(i)=exp(18.42)
        endif
        phat(i)=1./(real(n2)+real(n1)*thetahat(i))
c        write(6,*) 'posval()=',posval(i)
c        write(6,*) 'phat()=',phat(i)
  260 continue
      sum=0.0 
      do 265 i=1,n1
        sum=sum+alphahat+betahat*h(i)
  265 continue
c      write(6,*) 'sum log(thetahat) over first group =',sum
c
c   Calculate p2hat, the discrete elements of underlying distribution
c   2-dim Model
c
      do 267 i=1,n1+n2
        if (lam1hat .eq. 0. .and. lam2hat .eq. 0.) then
          h1(i)=log(posval(i))
          h2(i)=log(posval(i))
        else
          if (lam1hat .eq. 0.) then
            h1(i)=log(posval(i))
            h2(i)=(posval(i)**(lam2hat)-1.)/lam2hat
          else
            if (lam2hat .eq. 0.) then
              h1(i)=(posval(i)**(lam1hat)-1.)/lam1hat
              h2(i)=log(posval(i))
            else
              h1(i)=(posval(i)**(lam1hat)-1.)/lam1hat
              h2(i)=(posval(i)**(lam2hat)-1.)/lam2hat
            endif
          endif
        endif
        zz=alphat+beta1hat*h1(i)+beta2hat*h2(i)
        if (zz .lt. 18.42) then
          theta2h(i)=exp(zz)
        else
          theta2h(i)=exp(18.42)
        endif
        p2hat(i)=1./(real(n2)+real(n1)*theta2h(i))
c        write(6,*) 'posval()=',posval(i)
c        write(6,*) 'p2hat()=',p2hat(i)
  267 continue
      sum2=0.0 
      do 268 i=1,n1
        sum2=sum2+alphat+beta1hat*h1(i)+beta2hat*h2(i)
  268 continue
c      write(6,*) 'sum log(theta2h) over first group =',sum2
c
c   Order posval and make corresponding changes to phat,thetahat,p2hat,theta2h
c
      do 280 i=1,n1+n2-1
        do 270 j=i+1,n1+n2
          if (posval(j) .lt. posval(i)) then 
            temp=posval(i)
            posval(i)=posval(j) 
            posval(j)=temp
            temp=thetahat(i)
            thetahat(i)=thetahat(j) 
            thetahat(j)=temp
            temp=phat(i)
            phat(i)=phat(j) 
            phat(j)=temp
            temp=theta2h(i)
            theta2h(i)=theta2h(j) 
            theta2h(j)=temp
            temp=p2hat(i)
            p2hat(i)=p2hat(j) 
            p2hat(j)=temp
          endif
  270   continue
  280 continue
c------------------------------------------------------------------
c  SEMIPARAMETRIC MAXIMUM LIKELIHOOD (1-dim Model)
c
c  Calculate estimate of NBFH parameter
c
      semp=0.0
      do 292 i=1,n1+n2
        temp=0.0
        do 290 j=i+1,n1+n2 
          temp=temp+phat(j)   
  290   continue
        semp=semp+(temp+.5*phat(i))*phat(i)*thetahat(i)
  292 continue
      avg1p=avg1p+semp
      write(6,*) '1-dim Semiparametric estimate of p is ',semp
      semp=abs(semp-.5)
c      write(6,*) '1-dim Semiparametric test statistic is ',semp
c
c  Calculate Asymptotic Distribution of Beta^
c
      a11=0.0 
      a21=0.0 
      a22=0.0 
      do 293 i=1,n1+n2 
        if (lamhat .eq. 0.) then
          expterm=alphahat+betahat*log(posval(i))
          if (expterm .gt. 30.) then
            a11=a11+phat(i)*1.0686e13/
     *          (1.+1.0686e13*real(n1)/real(n2))
            a21=a21+phat(i)*1.0686e13*log(posval(i))/
     *          (1.+1.0686e13*real(n1)/real(n2))
            a22=a22+phat(i)*1.0686e13*log(posval(i))**2/
     *          (1.+1.0686e13*real(n1)/real(n2))
          else 
            a11=a11+phat(i)*exp(expterm)/
     *          (1.+exp(expterm)*real(n1)/real(n2))
            a21=a21+phat(i)*exp(expterm)*log(posval(i))/
     *          (1.+exp(expterm)*real(n1)/real(n2))
            a22=a22+phat(i)*exp(expterm)*log(posval(i))**2/
     *          (1.+exp(expterm)*real(n1)/real(n2))
          endif
        else
          expterm=alphahat+betahat*(posval(i)**lamhat-1.)/lamhat
          if (expterm .gt. 30.) then
            a11=a11+phat(i)*1.0686e13/
     *          (1.+1.0686e13*real(n1)/real(n2))
            a21=a21+phat(i)*1.0686e13*(posval(i)**lamhat-1.)/
     *          (lamhat*(1.+1.0686e13*real(n1)/real(n2)))
            a22=a22+phat(i)*1.0686e13*(posval(i)**lamhat-1.)**2/
     *          (lamhat**2*(1.+1.0686e13*real(n1)/real(n2)))
          else 
            a11=a11+phat(i)*exp(expterm)/
     *          (1.+exp(expterm)*real(n1)/real(n2))
            a21=a21+phat(i)*exp(expterm)*((posval(i)**lamhat-1.)
     *          /lamhat)/((1.+exp(expterm)*real(n1)/real(n2)))
            a22=a22+phat(i)*exp(expterm)*
     *          (posval(i)**lamhat-1.)**2/
     *          (lamhat**2*(1.+exp(expterm)*real(n1)/real(n2)))
          endif
        endif
  293 continue
c      write(6,*) 'a11= ',a11
c      write(6,*) 'a21= ',a21
c      write(6,*) 'a22= ',a22
c      write(6,*) '-----------------------------------'
c
c  Invert A
c
      determ=abs(a11*a22-a21**2)
      temp=a11
      ainv11=a22/(determ)
      ainv22=temp/(determ)
      ainv21=-1.*a21/determ
c      write(6,*) 'After Inversion'
c      write(6,*) 'ainv11= ',ainv11
c      write(6,*) 'ainv21= ',ainv21
c      write(6,*) 'ainv22= ',ainv22
c      write(6,*) '-----------------------------------'
c
c  Form Covariance Matrix
c 
      cov11=ainv11-1.-real(n1)/real(n2)
      cov11=cov11*real(n1+n2)/real(n1)
      cov21=ainv21*real(n1+n2)/real(n1)
      cov22=ainv22*real(n1+n2)/real(n1)
c      write(6,*) 'Covariance Matrix'
c      write(6,*) 'cov11= ',cov11
c      write(6,*) 'cov21= ',cov21
c      write(6,*) 'cov22= ',cov22
c      write(6,*) '-----------------------------------'
c
c  Form standardized coefficient
c
      semt=betahat*sqrt(real(n1+n2))/sqrt(cov22)
c
c  Use approximate Normal null distribution to test H_0
c
      pow4sem=2.*(1.-anordf(abs(semt)))
c      write(6,*) 'Rep #',irep
c      write(6,*) 'Semiparametric standardized test stat.=',semt
c      write(6,*) '-----------------------------------'
c
c  Calculate VAR[h(x)]
c
      vh=0.0
      vh1=0.0
      semt5=0.0
      do 295 i=1,n1+n2
        if (lamhat.eq. 0.) then
          vh=vh+phat(i)*(log(posval(i)))**2
          vh1=vh1+phat(i)*log(posval(i))
          semt5=semt5+log(phat(i))
        else
          vh=vh+phat(i)*(posval(i)**lamhat-1.)**2/(lamhat**2)
          vh1=vh1+phat(i)*(posval(i)**lamhat-1.)/(lamhat)
          semt5=semt5+log(phat(i))
        endif
  295 continue
c      write(6,*) 'E[h]=',vh1
c      write(6,*) 'E[h^2]=',vh
      vh=vh-vh1**2
c      write(6,*) 'Var[h]=',vh
c      write(6,*) '-----------------------------------'
c
c  Use approximate Chi-squared null distribution to test H_0
c
      semt2=real(n1+n2)*real(n2)*betahat**2/
     *       (real(n1)*(1.+real(n2)/real(n1))**2)
      semt2=semt2*vh
      pow5sem=2.*(1.-chidf(abs(semt2),1.0))
c      write(6,*) 'chi-squared t.s.=',semt2
c      write(6,*) '-----------------------------------'
c
c  Use LRT with chi-squared null dist to test H_0
c
      semt5=semt5+sum+real(n1+n2)*log(real(n1+n2))
      semt5=semt5*2. 
      pow3lsem=2.*(1.-chidf(abs(semt5),2.0))
c      write(6,*) semt5
c      write(6,*) '-----------------------------------'
c
c  Use LRT to test H_0
c
      semtlrt=semt5
c      write(6,*) '1-DIM Semi-par LRT =',semtlrt
c      write(6,*) '-----------------------------------'
c
c   Brunner Formula (No longer used)
c  Use approximate Normal null distribution of phat to test H_0
c
c      term1=0.0
c      term2=0.0
c      g1=0.0
c      g2=0.0
c      do 300 i=1,n1+n2
c        g1=g1+.5*phat(i)*thetahat(i)
c        g2=g2+.5*phat(i)
c        term1=term1+phat(i)*(g1-.5)**2
c        term2=term2+phat(i)*thetahat(i)*(g2-.5)**2
c        g1=g1+.5*phat(i)*thetahat(i)
c        g2=g2+.5*phat(i)
c  300 continue
c      var=real(n1+n2)*(term1/real(n1)+term2/real(n2))
c      write(6,*) 'sigma_1^2=',term1
c      write(6,*) 'sigma_2^2=',term2
c      write(6,*) 'G_1(inf)=',g1
c      write(6,*) 'G_2(inf)=',g2
c      write(6,*) '1-dim Semi asym VAR(phat) is ',var
c      semp3=semp*sqrt(real(n1+n2))/sqrt(var)
c      write(6,*) semp3
c      write(6,*) '1-DIM Semi ts based on asym phat =',semp3
c      write(6,*) '-----------------------------------'
c      if (abs(semp3) .gt. anorin(1.-sig/2.)) sem3rej=sem3rej+1
c      if (abs(semp3) .gt. anorin(1.-sig/2.)) write(6,*) 'REJECT'
c
c  Use new formula from Kostas
c  
      s11=a11*real(n1)/real(n1+n2)
      s21=a21*real(n1)/real(n1+n2)
      s22=a22*real(n1)/real(n1+n2)
      g1dist=0.0 
      g2dist=0.0 
      delta1=0.0
      delta2=0.0
      e1=0.0
      e2=0.0
      e3=0.0
      e4=0.0
      do 305 i=1,n1+n2
        g1dist=g1dist+phat(i)*thetahat(i)
        g2dist=g2dist+phat(i)
        yy(i)=thetahat(i)/(real(n2)/real(n1)+thetahat(i))
        w(i)=1./(1.+real(n1)*thetahat(i)/real(n2))
        kappa(i)=g1dist-thetahat(i)*g2dist
        delta1=delta1+yy(i)*(g1dist+g2dist*real(n2)/real(n1))*phat(i)
        if (lamhat .eq. 0.) then
          delta2=delta2+yy(i)*(g1dist+g2dist*real(n2)/real(n1))*
     *     log(posval(i))*phat(i)
        else
          delta2=delta2+yy(i)*(g1dist+g2dist*real(n2)/real(n1))*
     *     (posval(i)**lamhat-1.)*phat(i)/lamhat
        endif 
        e1=e1+kappa(i)**2*w(i)*phat(i)
        e2=e2+kappa(i)*thetahat(i)*w(i)*phat(i)
        e3=e3+kappa(i)*w(i)*phat(i)
        e4=e4+kappa(i)*(1.-thetahat(i))*w(i)*phat(i)
  305 continue
c      write(6,*) 'minimum transformed value=',posval(1)-1
c      write(6,*) 'e1=',e1
c      write(6,*) 'e2=',e2
c      write(6,*) 'e3=',e3
c      write(6,*) 'e4=',e4
c      write(6,*) 'delta1=',delta1
c      write(6,*) 'delta2=',delta2
      var=real(n1+n2)*(e1-real(n1)*e2**2/real(n2)-e3**2)/real(n2) 
      var=var+delta1**2*cov11+2.*delta1*delta2*cov21+delta2**2*cov22 
      var=var-2.*real(n1+n2)*e4*(delta1*a11*ainv11+delta2*a11*ainv21+
     *            delta1*a21*ainv21+delta2*a21*ainv22)/real(n2)
c      write(6,*) 'New Formula 1-dim Semi asym VAR(phat) is ',var
      semp3=semp*sqrt(real(n1+n2))/sqrt(var)
      pow3sem=2.*(1.-anordf(abs(semp3)))
c
c=========================================================
c  SEMIPARAMETRIC MAXIMUM LIKELIHOOD (2-dim Model)
c
c  Calculate estimate of NBFH parameter P
c
      semt2lrt=0.0
      sem2p=0.0
      do 315 i=1,n1+n2
        semt2lrt=semt2lrt+log(p2hat(i))
        temp=0.0
        do 313 j=i+1,n1+n2 
          temp=temp+p2hat(j)   
  313   continue
        sem2p=sem2p+(temp+.5*phat(i))*p2hat(i)*theta2h(i)
  315 continue
      avgp=avgp+sem2p
      write(6,*) '2-dim Semiparametric estimate of p is ',sem2p
      sem2p=abs(sem2p-.5)
c      write(6,*) '2-dim Semiparametric test statistic is ',sem2p
c
c  Use approximate Normal null distribution of phat to test H_0
c
c      term1=0.0
c      term2=0.0
c      g1=0.0
c      g2=0.0
c      do 318 i=1,n1+n2
c        g1=g1+.5*p2hat(i)*theta2h(i)
c        g2=g2+.5*p2hat(i)
c        term1=term1+p2hat(i)*(g1-.5)**2
c        term2=term2+p2hat(i)*theta2h(i)*(g2-.5)**2
c        g1=g1+.5*p2hat(i)*theta2h(i)
c        g2=g2+.5*p2hat(i)
c  318 continue
c      var=real(n1+n2)*(term1/real(n1)+term2/real(n2))
c      write(6,*) 'sigma_1^2=',term1
c      write(6,*) 'sigma_2^2=',term2
c      write(6,*) 'g_1(inf)=',g1
c      write(6,*) 'g_2(inf)=',g2
c      write(6,*) '2-DIM Semi asym VAR(phat) is ',var
      
c      semp23=sem2p*sqrt(real(n1+n2))/sqrt(var)
c      write(6,*) '2-DIM Semi ts based on asym phat=',semp23
c      write(6,*) '-----------------------------------'
c      if (abs(semp23) .gt. anorin(1.-sig/2.)) sem23rej=sem23rej+1
c
c  Use LRT with chi-squared null dist to test H_0
c
      semt2lrt=semt2lrt+sum2+real(n1+n2)*log(real(n1+n2))
      semt2lrt=semt2lrt*2. 
      pow23lse=2.*(1.-chidf(abs(semt2lrt),2.0))
c  
c  Use Formula from Kostas
      a(1,1)=0.0 
      a(2,1)=0.0 
      a(2,2)=0.0 
      a(3,1)=0.0 
      a(3,2)=0.0 
      a(3,3)=0.0 
      do 320 i=1,n1+n2 
        if (lam1hat .eq. 0.) then
          expterm=alphat+beta1hat*log(posval(i))+beta2hat*
     *              (posval(i)**lam2hat-1.)/lam2hat
        else
          if (lam2hat .eq. 0.) then
            expterm=alphat+beta2hat*log(posval(i))+beta1hat*
     *              (posval(i)**lam1hat-1.)/lam1hat
          else
            expterm=alphat+beta1hat*(posval(i)**lam1hat-1.)
     *                /lam1hat
            expterm=expterm+beta2hat*(posval(i)**lam2hat-1.)
     *                /lam2hat
          endif
        endif
        if (lam1hat .eq. 0) then
          if (expterm .gt. 30.) then
            a(1,1)=a(1,1)+p2hat(i)*1.0686e13/
     *          (1.+1.0686e13*real(n1)/real(n2))
            a(2,1)=a(2,1)+p2hat(i)*1.0686e13*log(posval(i))/
     *          (1.+1.0686e13*real(n1)/real(n2))
            a(2,2)=a(2,2)+p2hat(i)*1.0686e13*log(posval(i))**2/
     *          (1.+1.0686e13*real(n1)/real(n2))
            a(3,1)=a(3,1)+p2hat(i)*1.0686e13*(posval(i)**lam2hat-1.)/
     *            (lam2hat*(1.+1.0686e13*real(n1)/real(n2)))
            a(3,2)=a(3,2)+p2hat(i)*1.0686e13*log(posval(i))*(posval(i)
     *            **lam2hat-1.)/
     *            (lam2hat*(1.+1.0686e13*real(n1)/real(n2)))
            a(3,3)=a(3,3)+p2hat(i)*1.0686e13*(posval(i)**lam2hat-1.)**2/
     *            (lam2hat**2*(1.+1.0686e13*real(n1)/real(n2)))
          else 
            a(1,1)=a(1,1)+p2hat(i)*exp(expterm)/
     *          (1.+exp(expterm)*real(n1)/real(n2))
            a(2,1)=a(2,1)+p2hat(i)*exp(expterm)*log(posval(i))/
     *          (1.+exp(expterm)*real(n1)/real(n2))
            a(2,2)=a(2,2)+p2hat(i)*exp(expterm)*log(posval(i))**2/
     *          (1.+exp(expterm)*real(n1)/real(n2))
            a(3,1)=a(3,1)+p2hat(i)*exp(expterm)*(posval(i)**lam2hat-1.)/
     *            (lam2hat*(1.+exp(expterm)*real(n1)/real(n2)))
            a(3,2)=a(3,2)+p2hat(i)*exp(expterm)*log(posval(i))*
     *            (posval(i)**lam2hat-1.)/
     *            (lam2hat*(1.+exp(expterm)*real(n1)/real(n2)))
            a(3,3)=a(3,3)+p2hat(i)*exp(expterm)*(posval(i)**lam2hat-1.)
     *         **2/(lam2hat**2*(1.+exp(expterm)*real(n1)/real(n2)))
          endif
        else 
          if (lam2hat .eq. 0.) then
            if (expterm .gt. 30.) then
              a(1,1)=a(1,1)+p2hat(i)*1.0686e13/
     *            (1.+1.0686e13*real(n1)/real(n2))
              a(2,1)=a(2,1)+p2hat(i)*1.0686e13*(posval(i)**lam1hat-1.)/
     *            (lam1hat*(1.+1.0686e13*real(n1)/real(n2)))
              a(2,2)=a(2,2)+p2hat(i)*1.0686e13*(posval(i)**lam1hat-1.)
     *            **2/(lam1hat**2*(1.+1.0686e13*real(n1)/real(n2)))
              a(3,1)=a(3,1)+p2hat(i)*1.0686e13*log(posval(i))/
     *            (1.+1.0686e13*real(n1)/real(n2))
              a(3,2)=a(3,2)+p2hat(i)*1.0686e13*log(posval(i))*
     *            (posval(i)**lam1hat-1.)/
     *            (lam1hat*(1.+1.0686e13*real(n1)/real(n2)))
              a(3,3)=a(3,3)+p2hat(i)*1.0686e13*log(posval(i))**2/
     *            (1.+1.0686e13*real(n1)/real(n2))
            else 
              a(1,1)=a(1,1)+p2hat(i)*exp(expterm)/
     *            (1.+exp(expterm)*real(n1)/real(n2))
              a(2,1)=a(2,1)+p2hat(i)*exp(expterm)*
     *            (posval(i)**lam1hat-1.)/(lam1hat*(1.+exp(expterm)*
     *            real(n1)/real(n2)))
              a(2,2)=a(2,2)+p2hat(i)*exp(expterm)*
     *            (posval(i)**lam1hat-1.)**2/(lam1hat**2*
     *            (1.+exp(expterm)*real(n1)/real(n2)))
              a(3,1)=a(3,1)+p2hat(i)*exp(expterm)*log(posval(i))/
     *            (1.+exp(expterm)*real(n1)/real(n2))
              a(3,2)=a(3,2)+p2hat(i)*exp(expterm)*log(posval(i))*
     *            (posval(i)**lam1hat-1.)/
     *            (lam1hat*(1.+exp(expterm)*real(n1)/real(n2)))
              a(3,3)=a(3,3)+p2hat(i)*exp(expterm)*log(posval(i))**2/
     *            (1.+exp(expterm)*real(n1)/real(n2))
            endif
          else
            if (expterm .gt. 30.) then
              a(1,1)=a(1,1)+p2hat(i)*1.0686e13/
     *            (1.+1.0686e13*real(n1)/real(n2))
              a(2,1)=a(2,1)+p2hat(i)*1.0686e13*(posval(i)**lam1hat-1.)/
     *            (lam1hat*(1.+1.0686e13*real(n1)/real(n2)))
              a(2,2)=a(2,2)+p2hat(i)*1.0686e13*(posval(i)**lam1hat-1.)
     *            **2/(lam1hat**2*(1.+1.0686e13*real(n1)/real(n2)))
              a(3,1)=a(3,1)+p2hat(i)*1.0686e13*(posval(i)**lam2hat-1.)/
     *            (lam2hat*(1.+1.0686e13*real(n1)/real(n2)))
              a(3,2)=a(3,2)+p2hat(i)*1.0686e13*(posval(i)**lam2hat-1.)*
     *            (posval(i)**lam1hat-1.)/
     *            (lam1hat*lam2hat*(1.+1.0686e13*real(n1)/real(n2)))
              a(3,3)=a(3,3)+p2hat(i)*1.0686e13*(posval(i)**lam2hat-1.)
     *            **2/(lam2hat**2*(1.+1.0686e13*real(n1)/real(n2)))
            else 
              a(1,1)=a(1,1)+p2hat(i)*exp(expterm)/
     *            (1.+exp(expterm)*real(n1)/real(n2))
              a(2,1)=a(2,1)+p2hat(i)*exp(expterm)*
     *            (posval(i)**lam1hat-1.)/(lam1hat*(1.+exp(expterm)*
     *            real(n1)/real(n2)))
              a(2,2)=a(2,2)+p2hat(i)*exp(expterm)*
     *            (posval(i)**lam1hat-1.)**2/(lam1hat**2*
     *            (1.+exp(expterm)*real(n1)/real(n2)))
              a(3,1)=a(3,1)+p2hat(i)*exp(expterm)*
     *            (posval(i)**lam2hat-1.)/(lam2hat*
     *            (1.+exp(expterm)*real(n1)/real(n2)))
              a(3,2)=a(3,2)+p2hat(i)*exp(expterm)*
     *            (posval(i)**lam2hat-1.)*(posval(i)**lam1hat-1.)/
     *            (lam1hat*lam2hat*(1.+exp(expterm)*real(n1)/real(n2)))
              a(3,3)=a(3,3)+p2hat(i)*exp(expterm)*
     *            (posval(i)**lam2hat-1.)**2/(lam2hat**2*
     *            (1.+exp(expterm)*real(n1)/real(n2)))
            endif
          endif
        endif
  320 continue
      a(1,2)=a(2,1)
      a(1,3)=a(3,1)
      a(2,3)=a(3,2)
c      write(6,*) 'a(.,1)=',(a(i,1),i=1,3)
c      write(6,*) 'a(.,2)=',(a(i,2),i=2,3)
c      write(6,*) 'a(.,3)=',a(3,3)
c
c  Invert A
c
      call dlinds(3,a,3,dainv,3)
c
c  Check inverse
c      call dmrrrr(3,3,a,3,3,3,dainv,3,3,3,ccc,3)
c      write(6,*) 'a a^-1(1,.)=',(ccc(1,i),i=1,3)
c      write(6,*) 'a a^-1(2,.)=',(ccc(2,i),i=1,3)
c      write(6,*) 'a a^-1(3,.)=',(ccc(3,i),i=1,3)

      ainv(1,1)=dainv(1,1)
      ainv(1,2)=dainv(1,2)
      ainv(1,3)=dainv(1,3)
      ainv(2,1)=dainv(2,1)
      ainv(2,2)=dainv(2,2)
      ainv(2,3)=dainv(2,3)
      ainv(3,1)=dainv(3,1)
      ainv(3,2)=dainv(3,2)
      ainv(3,3)=dainv(3,3)

      cov(1,1)=ainv(1,1)-real(n1+n2)/real(n2)
      cov(1,1)=cov(1,1)*real(n1+n2)/real(n1)
      cov(2,1)=ainv(2,1)*real(n1+n2)/real(n1)
      cov(2,2)=ainv(2,2)*real(n1+n2)/real(n1)
      cov(3,1)=ainv(3,1)*real(n1+n2)/real(n1)
      cov(3,2)=ainv(3,2)*real(n1+n2)/real(n1)
      cov(3,3)=ainv(3,3)*real(n1+n2)/real(n1)
      cov(2,3)=cov(3,2)
      cov(1,3)=cov(3,1)
      cov(1,2)=cov(2,1)
c      write(6,*) 'ainv(.,1)=',(ainv(i,1),i=1,3)
c      write(6,*) 'ainv(.,2)=',(ainv(i,2),i=2,3)
c      write(6,*) 'ainv(.,3)=',ainv(3,3)
c      write(6,*) 'cov(.,1)=',(cov(i,1),i=1,3)
c      write(6,*) 'cov(.,2)=',(cov(i,2),i=2,3)
c      write(6,*) 'cov(.,3)=',cov(3,3)
c
      g1dist=0.0 
      g2dist=0.0 
      delta(1,1)=0.0
      delta(2,1)=0.0
      delta(3,1)=0.0
      e1=0.0
      e2=0.0
      e3=0.0
      e4=0.0
      do 322 i=1,n1+n2
        g1dist=g1dist+p2hat(i)*theta2h(i)
        g2dist=g2dist+p2hat(i)
        yy(i)=theta2h(i)/(real(n2)/real(n1)+theta2h(i))
        w(i)=1./(1.+real(n1)*theta2h(i)/real(n2))
        kappa(i)=g1dist-theta2h(i)*g2dist
        delta(1,1)=delta(1,1)+yy(i)*(g1dist+g2dist*real(n2)/real(n1))*
     *     p2hat(i)
        if (lam1hat .eq. 0.) then
          delta(2,1)=delta(2,1)+yy(i)*(g1dist+g2dist*real(n2)/real(n1))*
     *     log(posval(i))*p2hat(i)
        else
          delta(2,1)=delta(2,1)+yy(i)*(g1dist+g2dist*real(n2)/real(n1))*
     *     (posval(i)**lam1hat-1.)*p2hat(i)/lam1hat
        endif 
        if (lam2hat .eq. 0.) then
          delta(3,1)=delta(3,1)+yy(i)*(g1dist+g2dist*real(n2)/real(n1))*
     *     log(posval(i))*p2hat(i)
        else
          delta(3,1)=delta(3,1)+yy(i)*(g1dist+g2dist*real(n2)/real(n1))*
     *     (posval(i)**lam2hat-1.)*p2hat(i)/lam2hat
        endif 
        e1=e1+kappa(i)**2*w(i)*p2hat(i)
        e2=e2+kappa(i)*theta2h(i)*w(i)*p2hat(i)
        e3=e3+kappa(i)*w(i)*p2hat(i)
        e4=e4+kappa(i)*(1.-theta2h(i))*w(i)*p2hat(i)
  322 continue 
c      write(6,*) 'e1=',e1
c      write(6,*) 'e2=',e2
c      write(6,*) 'e3=',e3
c      write(6,*) 'e4=',e4
c      write(6,*) 'delta1=',delta(1,1)
c      write(6,*) 'delta2=',delta(2,1)
c      write(6,*) 'delta3=',delta(3,1)
      var=real(n1+n2)*(e1-real(n1)*e2**2/real(n2)-e3**2)/real(n2) 
c      write(6,*) '1st term:New Formula 2D Semi asy VAR(phat)=',var
      call mxtyf(3,1,delta,3,3,3,cov,3,1,3,cc,1)
c      cc(1,1)=delta(1,1)*cov(1,1)+delta(2,1)*cov(1,2)+delta(3,1)*
c     *         cov(1,3)
c      cc(1,2)=delta(1,1)*cov(2,1)+delta(2,1)*cov(2,2)+delta(3,1)*
c     *         cov(2,3)
c      cc(1,3)=delta(1,1)*cov(3,1)+delta(2,1)*cov(3,2)+delta(3,1)*
c     *         cov(3,3)
c      write(6,*) 'deltaT COV(1)=',cc(1,1)
c      write(6,*) 'deltaT COV(2)=',cc(1,2)
c      write(6,*) 'deltaT COV(3)=',cc(1,3)
      var=var+cc(1,1)*delta(1,1)+cc(1,2)*delta(2,1)+cc(1,3)*delta(3,1)
c      write(6,*) '1+2 term:New Formula 2D Semi asy VAR(phat)=',var
      call mxtyf(3,1,delta,3,3,3,ainv,3,1,3,cc,1)
c      cc(1,1)=delta(1,1)*ainv(1,1)+delta(2,1)*ainv(1,2)+delta(3,1)*
c     *          ainv(1,3)
c      cc(1,2)=delta(1,1)*ainv(2,1)+delta(2,1)*ainv(2,2)+delta(3,1)*
c     *          ainv(2,3)
c      cc(1,3)=delta(1,1)*ainv(3,1)+delta(2,1)*ainv(3,2)+delta(3,1)*
c     *          ainv(3,3)
      var=var-2.*real(n1+n2)*e4*(
     *            cc(1,1)*a(1,1)+cc(1,2)*a(2,1)+cc(1,3)*a(3,1)
     *            )/real(n2)
c      write(6,*) 'New Formula 2-dim Semi asym VAR(phat) is ',var
      semp23=sem2p*sqrt(real(n1+n2))/sqrt(var)
      pow23sem=2.*(1.-anordf(abs(semp23)))
c      
c
c      write(6,*) '2-DIM Semi ts based on asym phat=',semp23
c      write(6,*) '-----------------------------------'
c=========================================================
c   GENERALIZED LIKELIHOOD RATIO
c
c  To skip LRT
c
      if (testlrt .eq. 0.0 .and. testsim .eq. 0.0) go to 501
c
c  Start General MLE search
c
      xguess(1)=0.0
      nroot=1
      errabs=.001
      errrel=.001
      itmax=100

c      if (irep .eq. 3749) then
c      write(6,*) 'xguess=',xguess
c      endif

      call zreal(fcn,errabs,errrel,eps,eta,nroot,itmax,xguess,
     *           sol,info)

      lam1=sol(1) 

c      if (irep .eq. 3749) then
c      write(6,*) '----------------------------------------'
c      write(6,*) 'Solution from ZREAL'
c      write(6,*) 'lam1=',lam1
c      endif

      call pcalc(lam1,p,q)

c      if (irep .eq. 3749) then
c      write(6,*) '-----------------------------------------'
c      write(6,*) 'p=',(p(i),i=1,nprime)
c      write(6,*) 'q=',(q(i),i=1,nprime)
c      write(6,*) 'psum=',psum(nprime)
c      endif



c 
c  Check feasibility of solution
c
      qsum=0.0
      con3=0.0
      do 335 i=1,nprime
        qsum=qsum+q(i)
        theta=1.-psum(i)-psum(i-1)
        if (real(n2)+lam1*theta .ne. 0.0) then
          con3=con3+(1.-psum(i))*real(mprime(i))/(real(n2)+lam1*theta)
          con3=con3-real(mprime(i))*psum(i-1)/(real(n2)+lam1*theta)
        else
          con3=99999.
        endif
  335 continue

      flag=0.0
      do 337 i=1,nprime
        if (p(i) .gt. 1. .or. p(i) .lt. 0.) flag=1.0
        if (q(i) .gt. 1. .or. q(i) .lt. 0.) flag=1.0
  337 continue
      if (abs(psum(nprime)-1.0) .gt. tol) flag=1.0
      if (abs(qsum-1.0) .gt. tol) flag=1.0
      if (abs(con3) .gt. tol) flag=1.0
c  Solution feasible then bypass grid search
      if (flag .eq. 0.0) then
c        write(6,*) 'Solution from ZREAL'
c        write(6,*) 'lam1=',lam1
c        write(6,*) 'p()=',(p(i),i=1,nprime)
c        write(6,*) 'q()=',(q(i),i=1,nprime)
c        write(6,*) 'psum=',psum(nprime)
c        write(6,*) 'qsum=',qsum
c        write(6,*) 'con3',con3
         go to 480
       endif
c  Solution infeasible then do grid search for starting point
c  Search from max{mprime_1 - n_2, m_nprime - n_1} to max{(n_1-m_1)/(1-mprime_1/n_2), (n_2-mprime_nprime)/(1-m_nprime/n_1)}
c
c      write(6,*) '------------------------------'
c      write(6,*) '------------------------------'
c      write(6,*) 'First Solution infeasible'
c      write(6,*) 'Start Grid Search'
c      write(6,*) 'psum(nprime)=',psum(nprime)
c      write(6,*) 'qsum=',qsum
c      write(6,*) 'con3=',con3
c
c   GRID SEARCH  (of increment=.1)
c
      inc=.1
      conmin=999999.

      ilowbdd=-1.*srchmul*real(n1)
      izz=-1.*srchmul*real(n2)
      if (izz .lt. ilowbdd) ilowbdd=izz
      
      iuppbdd=srchmul*real(n1)
      izz=srchmul*real(n2)
      if (izz .gt. iuppbdd) iuppbdd=izz

c      write(6,*) 'ilowbdd=',ilowbdd
c      write(6,*) 'iuppbdd=',iuppbdd

      do 350 i=10*ilowbdd,10*iuppbdd
        lam1=real(i)/10.
        call pcalc(lam1,p,q)
c        write(6,*) 'lam1=',lam1
c        write(6,*) 'p()=',(p(j),j=1,nprime)
        qsum=0.0
        con3=0.0
        do 340 j=1,nprime
          qsum=qsum+q(j)
          theta=1.-psum(j)-psum(j-1)
          if (real(n2)+lam1*theta .ne. 0.0) then
            con3=con3+(1.-psum(j))*real(mprime(j))/(real(n2)+lam1*theta)
            con3=con3-real(mprime(j))*psum(j-1)/(real(n2)+lam1*theta)
          else
            con3=99999.
          endif
  340   continue
c        write(6,*) 'q()=',(q(j),j=1,nprime)
c        write(6,*) 'deviation of psum=',abs(psum(nprime)-1.)
c        write(6,*) 'deviation of qsum=',abs(qsum-1.)
c        write(6,*) 'con3=',con3
c  Check feasibility
        flag=0.0
        do 347 j=1,nprime
          if (p(j) .gt. 1. .or. p(j) .lt. 0.) flag=1.0
          if (q(j) .gt. 1. .or. q(j) .lt. 0.) flag=1.0
  347   continue
        consum=abs(con3)+abs(psum(nprime)-1.0)+abs(qsum-1.0)
c        write(6,*) 'total deviation=',consum
        if (consum .lt. conmin .and. flag .eq. 0.0) then
          conmin=consum
          lam1min=lam1
        endif
  350 continue

c      write(6,*) 'minimum from grid search occurs at lam1=',lam1min
c      write(6,*) 'sum of constraint deviations=',conmin
c
c  Start ZREAL starting at min from grid search
c
c      write(6,*) '-------------------------------------'
c      write(6,*) '-------------------------------------'
c      write(6,*) 'Start again at ',lam1min
      xguess(1)=lam1min
      nroot=1
      errabs=.001
      errrel=.001
      itmax=100

      call zreal(fcn,errabs,errrel,eps,eta,nroot,itmax,xguess,
     *           sol,info)
      lam1=sol(1) 

c      write(6,*) '----------------------------------------'
c      write(6,*) 'Solution from ZREAL'
c      write(6,*) 'lam1=',lam1
      call pcalc(lam1,p,q)
c      write(6,*) '-----------------------------------------'
c      write(6,*) 'p=',(p(i),i=1,nprime)
c      write(6,*) 'q=',(q(i),i=1,nprime)
c      write(6,*) 'psum=',psum(nprime)

      qsum=0.0
      con3=0.0
      do 362 i=1,nprime
        qsum=qsum+q(i)
        theta=1.-psum(i)-psum(i-1)
        if (real(n2)+lam1*theta .ne. 0.0) then
          con3=con3+(1.-psum(i))*real(mprime(i))/(real(n2)+lam1*theta)
          con3=con3-real(mprime(i))*psum(i-1)/(real(n2)+lam1*theta)
        else
          con3=99999.
        endif
  362 continue
c      write(6,*) 'qsum=',qsum
c      write(6,*) 'con3=',con3
c 
c  Check feasibility of solution
c
      flag=0.0
      do 364 i=1,nprime
        if (p(i) .gt. 1. .or. p(i) .lt. 0.) flag=1.0
        if (q(i) .gt. 1. .or. q(i) .lt. 0.) flag=1.0
  364 continue
      if (abs(psum(nprime)-1.0) .gt. tol) flag=1.0
      if (abs(qsum-1.0) .gt. tol) flag=1.0
      if (abs(con3) .gt. tol) flag=1.0
      if (flag .eq. 0.) then
c        write(6,*) 'Solution from ZREAL'
c        write(6,*) 'lam1=',lam1
c        write(6,*) 'p()=',(p(i),i=1,nprime)
c        write(6,*) 'q()=',(q(i),i=1,nprime)
        go to 480
      endif

c  Convergence failed again, use grid search of (lam1min-.1,lam1min+.1)
c
c      write(6,*) 'Second Solution infeasible'
c      write(6,*) 'Start Grid search again near lam1min'
c
c   GRID SEARCH  (of increment=.01)
c
      conmin=999999.
      do 375 i=1,21
        lam1=lam1min-.1+.01*real(i-1)
        call pcalc(lam1,p,q)
c        write(6,*) 'lam1=',lam1
c        write(6,*) 'p()=',(p(j),j=1,nprime)
        qsum=0.0
        con3=0.0
        do 370 j=1,nprime
          qsum=qsum+q(j)
          theta=1.-psum(j)-psum(j-1)
          if (real(n2)+lam1*theta .ne. 0.0) then
            con3=con3+(1.-psum(j))*real(mprime(j))/
     *           (real(n2)+lam1*theta)
            con3=con3-real(mprime(j))*psum(j-1)/(real(n2)+lam1*theta)
          else
            con3=99999.
          endif
  370   continue 
c        write(6,*) 'q()=',(q(j),j=1,nprime)
c        write(6,*) 'con3=',con3
c  Check feasibility
      flag=0.0
      do 373 j=1,nprime
        if (p(j) .gt. 1. .or. p(j) .lt. 0.) flag=1.0
        if (q(j) .gt. 1. .or. q(j) .lt. 0.) flag=1.0
  373 continue
       consum=abs(con3)+abs(psum(nprime)-1.0)+abs(qsum-1.0)
       if (consum .lt. conmin .and. flag .eq. 0.0) then
         conmin=consum
         lam1m2=lam1
       endif
  375 continue
c      write(6,*) 'minimum from grid search occurs at lam1=',lam1m2
c      write(6,*) 'sum of constraint deviations=',conmin

c
c  Start ZREAL starting at min from grid search
c
c      write(6,*) '-------------------------------------'
c      write(6,*) '-------------------------------------'
c      write(6,*) 'Start again at ',lam1m2
      xguess(1)=lam1m2
      nroot=1
      errabs=.001
      errrel=.001
      itmax=100

      call zreal(fcn,errabs,errrel,eps,eta,nroot,itmax,xguess,
     *           sol,info)

      lam1=sol(1) 
      call pcalc(lam1,p,q)
      qsum=0.0
      con3=0.0
      do 382 i=1,nprime
        qsum=qsum+q(i)
        theta=1.-psum(i)-psum(i-1)
        if (real(n2)+lam1*theta .ne. 0.0) then
          con3=con3+(1.-psum(i))*real(mprime(i))/(real(n2)+lam1*theta)
          con3=con3-real(mprime(i))*psum(i-1)/(real(n2)+lam1*theta)
        else
          con3=99999.
        endif
  382 continue
c 
c  Check feasibility of solution
c
      flag=0.0
      do 384 i=1,nprime
        if (p(i) .gt. 1. .or. p(i) .lt. 0.) flag=1.0
        if (q(i) .gt. 1. .or. q(i) .lt. 0.) flag=1.0
  384 continue
      if (abs(psum(nprime)-1.0) .gt. tol) flag=1.0
      if (abs(qsum-1.0) .gt. tol) flag=1.0
      if (abs(con3) .gt. tol) flag=1.0
      if (flag .eq. 0.) then
c        write(6,*) 'Solution from ZREAL'
c        write(6,*) 'lam1=',lam1
c        write(6,*) 'p()=',(p(i),i=1,nprime)
c        write(6,*) 'q()=',(q(i),i=1,nprime)
        go to 480
      endif

c  Convergence failed again, use grid search of (lam1m2-.01,lam1m2+.01)
c
c      write(6,*) '-------------------------------'
c      write(6,*) '-------------------------------'
c      write(6,*) 'Third Solution infeasible'
c      write(6,*) 'Start again grid search near lam1m2'
c      write(6,*) 'lam1m2==',lam1m2
c      write(6,*) 'psum(nprime)=',psum(nprime)
c      write(6,*) 'qsum=',qsum
c      write(6,*) 'con3=',con3
c      write(6,*) 'lam1m3=',lam1m3
c
c   GRID SEARCH  (of increment .001)
c
      conmin=999999.
      do 395 i=1,21
        lam1=lam1m2-.01+.001*real(i-1)
        call pcalc(lam1,p,q)
c        write(6,*) 'lam1=',lam1
c        write(6,*) 'p()=',(p(j),j=1,nprime)
        qsum=0.0
        con3=0.0
        do 390 j=1,nprime
          qsum=qsum+q(j)
          theta=1.-psum(j)-psum(j-1)
          if (real(n2)+lam1*theta .ne. 0.0) then
            con3=con3+(1.-psum(j))*real(mprime(j))/
     *               (real(n2)+lam1*theta)
            con3=con3-real(mprime(j))*psum(j-1)/(real(n2)+lam1*theta)
          else
            con3=99999.
          endif 
  390   continue 
c        write(6,*) 'q()=',(q(j),j=1,nprime)
c        write(6,*) 'psum=',psum(nprime)
c        write(6,*) 'qsum=',qsum
c        write(6,*) 'con3=',con3
c  Check feasibility
        flag=0.0
        do 393 j=1,nprime
          if (p(j) .gt. 1. .or. p(j) .lt. 0.) flag=1.0
          if (q(j) .gt. 1. .or. q(j) .lt. 0.) flag=1.0
  393   continue
        consum=abs(con3)+abs(psum(n1)-1.0)+abs(qsum-1.0)
        if (consum .lt. conmin .and. flag .eq. 0.0) then
          conmin=consum
          lam1m3=lam1
c          write(6,*) 'lam1m3=',lam1m3
        endif
  395 continue

      lam1=lam1m3
c      write(6,*) 'search min at lam1=',lam1
      call pcalc(lam1,p,q)
      qsum=0.0
      con3=0.0
      do 476 j=1,nprime
        qsum=qsum+q(j)
        theta=1.-psum(j)-psum(j-1)
        if (real(n2)+lam1*theta .ne. 0.0) then
          con3=con3+(1.-psum(j))*real(mprime(j))/(real(n2)+lam1*theta)
          con3=con3-real(mprime(j))*psum(j-1)/(real(n2)+lam1*theta)
        else
          con3=999999.
        endif 
  476 continue 
c        write(6,*) 'psum=',psum(nprime)
c        write(6,*) 'qsum=',qsum
c        write(6,*) 'con3=',con3
c 
c  Check feasibility of solution
c
      flag=0.0
      do 477 i=1,nprime
        if (p(i) .gt. 1. .or. p(i) .lt. 0.) flag=1.0
        if (q(i) .gt. 1. .or. q(i) .lt. 0.) flag=1.0
  477 continue
      if (abs(psum(nprime)-1.0) .gt. tol) flag=1.0
      if (abs(qsum-1.0) .gt. tol) flag=1.0
      if (abs(con3) .gt. tol) flag=1.0
      if (flag .eq. 0.) then
c        write(6,*) 'Solution from GRID SEARCH'
c        write(6,*) 'lam1=',lam1
c        write(6,*) 'p()=',(p(i),i=1,nprime)
c        write(6,*) 'q()=',(q(i),i=1,nprime)
        go to 480
      endif
c      write(6,*) 'No feasible solution found for original data'
      nofeas=nofeas+1
      lrt1c=nsim
      lrt2c=nsim
      wbf2c=nsim
      sem2c=nsim
      sem22c=nsim
      wil2c=nsim
      wel2c=nsim
      nflag=1

      go to 501 
c---------------------------------------------------------
c
c  Form likelhood ratio test for H_0: Pr{ X > Y } = P{ X < Y }
c
  480 continue
c      write(6,*) '-----------------------------------------'
c      write(6,*) 'lambda_1=',lam1
c      write(6,*) 'p=',(p(i),i=1,nprime)
c      write(6,*) 'q=',(q(i),i=1,nprime)
c      write(6,*) 'psum=',psum(nprime)
c      write(6,*) 'qsum=',qsum
c      write(6,*) 'con3=',con3
      lrt=0.0
      do 485 i=1,nprime
        if (m(i) .ne. 0) then
          if (p(i) .ne. 0.0) then
            lrt=lrt+real(m(i))*log(real(m(i))/(real(n1)*p(i)))
          else
            lrt=99999.
          endif
        endif
        if (mprime(i) .ne. 0) then
          if (q(i) .ne. 0.0) then
            lrt=lrt+real(mprime(i))*log(real(mprime(i))/(real(n2)*q(i)))
          else
            lrt=99999.
          endif
        endif
  485 continue
  491 continue
      lrt=2.*lrt
c      write(6,*) '------------------------------------'
c      write(6,*) 'rep#=',irep
c      write(6,*) lrt
c
c  Use LRT with chi-squared(1) null dist to test H_0
c
c      if (lrt .gt. chiin(1.-sig,1.0)) lrt3rej=lrt3rej+1
      pow3lrt=2.*(1.-chidf(lrt,1.0)) 
c----------------------------------------------------------------
c
c   Save psum, qsum, nprime, and data for simulation use
c
      psum0(1)=psum(1)/psum(nprime)
      qsum0(1)=q(1)/qsum 
      data0(1)=data(1) 
      do 500 i=2,nprime
        psum0(i)=psum(i)/psum(nprime)
        qsum0(i)=qsum0(i-1)+q(i)/qsum
        data0(i)=data(i)
  500 continue 
      n0prime=nprime
c
c-----------------------------------------------------------
c-----------------------------------------------------------
  501 continue 

c  To skip permutation procedures
      if (testperm .eq. 0.0) go to 1001
c
c  Calculate permutational null distribution
c
      if (nflag .eq. 0) lrt1c=0
      wbf1c=0
      sem1c=0
      sem1lc=0
      wil1c=0
      wel1c=0
      sem21c=0
      sem21lc=0

      do 1000 isim=1,nsim
c        write(6,*) '--------------------------------------'
c        write(6,*) 'Perm. number',isim
c 
c  Simulate data from f=g  (Permutation distribution)
c  Recall that values holds the actual values for permutation sampling 
c
      call rnun(n1,rn)
      do 540 i=1,n1
        irnn=int(real((n1+n2-i+1))*rn(i))+i
        xstar(i)=values(irnn)
        temp=values(i)
        values(i)=values(irnn)
        values(irnn)=temp
  540 continue
      do 545 i=n1+1,n1+n2
        ystar(i-n1)=values(i)
  545 continue
c
c  posval holds the shifted positive actual values for Box-Cox transform
c    Shift such that smallest value .5
c
      do 550 i=1,n1+n2
        posval(i)=values(i)-min+.5
  550 continue
c
c      write(6,*) 'x* values= ',(xstar(i),i=1,n1)
c      write(6,*) 'y* values= ',(ystar(i),i=1,n2)
c      write(6,*) 'positive x values= ',(posval(i),i=1,n1)
c      write(6,*) 'positive y values= ',(posval(i),i=n1+1,n1+n2)
c
c  Welch t-test
c
      xbar=0.0
      do 555 i=1,n1
        xbar=xbar+xstar(i)
  555 continue
      xbar=xbar/real(n1)
      ybar=0.0
      do 556 i=1,n2
        ybar=ybar+ystar(i)
  556 continue
      ybar=ybar/real(n2)
      s1=0.0
      do 557 i=1,n1
        s1=s1+(xstar(i)-xbar)**2
  557 continue
      s1=s1/real(n1-1)
      s2=0.0
      do 558 i=1,n2
        s2=s2+(ystar(i)-ybar)**2
  558 continue
      s2=s2/real(n2-1)
      sd=s1/real(n1)+s2/real(n2)
      
      twelsim=(ybar-xbar)/sqrt(sd)
c
c  Use permutational null distribution to test H_0
c
      if (abs(twelsim) .ge. abs(twel)) wel1c=wel1c+1
c-----------------------------------------------------------
c
c  Order y values among themselves
c
c  n2prime=number of distinct y values
c  mprime(i) is the multiplicity of value y_(i)
c
      do 575 i=1,n2
        do 570 j=i+1,n2
          if (ystar(j) .lt. ystar(i)) then
            temp=ystar(i)
            ystar(i)=ystar(j)
            ystar(j)=temp
          endif
  570   continue
  575 continue
c      write(6,*) 'ord. y* values= ',(ystar(i),i=1,n2)
      n2prime=1
      mprime(1)=1
      i=2
      icount=0
  577 continue
c      write(6,*) 'n2prime= ',n2prime
      if (ystar(i) .eq. ystar(n2prime)) then 
        mprime(n2prime)=mprime(n2prime)+1
c        write(6,*) 'mprime(n2prime)= ',mprime(n2prime)
        icount=icount+1
        do 578 j=i,n2-1
          ystar(j)=ystar(j+1)
  578   continue
      else
        n2prime=n2prime+1
c        write(6,*) 'n2prime= ',n2prime
        mprime(n2prime)=1
c        write(6,*) 'mprime(n2prime)= ',mprime(n2prime)
        i=i+1
      endif
      if (i .lt. n2-icount+1) go to 577
c
c  Order x values among themselves
c
c  n1prime=number of distinct x values
c  m(i) is the multiplicity of value x_(i)
c
      do 590 i=1,n1
        do 580 j=i+1,n1
          if (xstar(j) .lt. xstar(i)) then
            temp=xstar(i)
            xstar(i)=xstar(j)
            xstar(j)=temp
          endif
  580   continue
  590 continue
      n1prime=1
      m(1)=1
      i=2
      icount=0
  592 continue
      if (xstar(i) .eq. xstar(n1prime)) then 
        m(n1prime)=m(n1prime)+1
        icount=icount+1
        do 593 j=i,n1-1
          xstar(j)=xstar(j+1)
  593   continue
      else
        n1prime=n1prime+1
        m(n1prime)=1
        i=i+1
      endif
      if (i .lt. n1-icount+1) go to 592

c      write(6,*) 'distinct ord. x* values= ',(xstar(i),i=1,n1prime)
c      write(6,*) 'distinct ord. y* values= ',(ystar(i),i=1,n2prime)
c      write(6,*) 'x multiplicities= ',(m(i),i=1,n1prime)
c      write(6,*) 'y multiplicities= ',(mprime(i),i=1,n2prime)
c      write(6,*) '-------------------------------------'
c
c  Set up data to hold combined data
c  Set up xrank to hold the order statistic number if the corresponding entry of data() is a x value
c  Set up yrank to hold the order statistic number if the corresponding entry of data() is a y value
c
      do 610 i=1,n1prime
        data(i)=xstar(i)
        yrank(i)=0
        xrank(i)=i
  610 continue
      do 615 i=1,n2prime
        msave(i)=mprime(i)
  615 continue
      do 620 i=1,n2prime
        data(n1prime+i)=ystar(i)
        yrank(n1prime+i)=i
        xrank(n1prime+i)=0
        m(n1prime+i)=0
        mprime(n1prime+i)=msave(i)
  620 continue
      do 625 i=1,n1prime
        mprime(i)=0
  625 continue
c      write(6,*) 'data values= ',(data(i),i=1,n1prime+n2prime)
c      write(6,*) 'x multiplicities= ',(m(i),i=1,n1prime+n2prime)
c      write(6,*) 'y multiplicities= ',(mprime(i),i=1,n1prime+n2prime)
c
c  Order the combined values
c
      do 650 i=1,n1prime+n2prime-1
        do 640 j=i+1,n1prime+n2prime
          if (data(j) .lt. data(i)) then
            temp=data(i)
            temp2=xrank(i)
            temp3=yrank(i)
            temp4=m(i)
            temp5=mprime(i)
            data(i)=data(j)
            xrank(i)=xrank(j)
            yrank(i)=yrank(j)
            m(i)=m(j)
            mprime(i)=mprime(j)
            data(j)=temp
            xrank(j)=temp2
            yrank(j)=temp3
            m(j)=temp4
            mprime(j)=temp5
          endif
  640   continue
  650 continue
c      write(6,*) 'ordered data values= ',(data(i),i=1,n1prime+n2prime)
c      write(6,*) 'x multiplicities= ',(m(i),i=1,n1prime+n2prime)
c      write(6,*) 'y multiplicities= ',(mprime(i),i=1,n1prime+n2prime)
c
c  Set up samcount(i) to give the combined ordered sample less than data(i)
c
      sumyrank=0.
      samcount(1)=0
      ysamc=0
      xsamc=0
      do 670 i=1,n1prime+n2prime
        if (yrank(i) .ne. 0) then
          midrank(i)=0.0
          do 660 j=samcount(i)+1,samcount(i)+mprime(i)
            midrank(i)=midrank(i)+real(j)
  660     continue
          ymidrank(i)=0.0
          do 661 j=ysamc+1,ysamc+mprime(i)
            ymidrank(i)=ymidrank(i)+real(j)
  661     continue
          ymidrank(i)=ymidrank(i)/real(mprime(i))
          ysamc=ysamc+mprime(i)
          midden=mprime(i)
          if (i .ne. 1) then
            if (data(i) .eq. data(i-1)) then
              do 662 j=samcount(i-1)+1,samcount(i-1)+m(i-1)
                midrank(i)=midrank(i)+real(j)
  662         continue
              midden=midden+m(i-1)
            endif
          endif
          midrank(i)=midrank(i)/real(midden)
          samcount(i+1)=samcount(i)+mprime(i)
          sumyrank=sumyrank+midrank(i)*real(mprime(i))
        endif
        if (xrank(i) .ne. 0) then
          midrank(i)=0.0
          do 665 j=samcount(i)+1,samcount(i)+m(i)
            midrank(i)=midrank(i)+real(j)
  665     continue
          xmidrank(i)=0.0
          do 666 j=xsamc+1,xsamc+m(i)
            xmidrank(i)=xmidrank(i)+real(j)
  666     continue
          xmidrank(i)=xmidrank(i)/real(m(i))
          xsamc=xsamc+m(i)
          midden=m(i)
          samcount(i+1)=samcount(i)+m(i)
          if (i .ne. n1prime+n2prime) then
            if (data(i) .eq. data(i+1)) then
              do 667 j=samcount(i+1)+1,samcount(i+1)+mprime(i+1)
                midrank(i)=midrank(i)+real(j)
  667         continue
              midden=midden+mprime(i+1)
            endif
          endif
          midrank(i)=midrank(i)/real(midden)
        endif
  670 continue
c      write(6,*) 'midrank= ',(midrank(i),i=1,n1prime+n2prime)
c      write(6,*) 'sumyrank= ',sumyrank
c      write(6,*) 'xmidrank=',(xmidrank(i),i=1,n1prime+n2prime)
c      write(6,*) 'ymidrank=',(ymidrank(i),i=1,n1prime+n2prime)
c
c  Wilcoxon Rank Sum Test
c
c  Use permutational null distribution to test H_0
c
      wilcox=sumyrank-.5*real(n2)*real(n1+n2+1)
      wilcox=wilcox*sqrt(12.)/sqrt(real(n1*n2)*real(n1+n2+1))

      if (abs(wilcox) .ge. abs(wilco0)) wil1c=wil1c+1
c      if (abs(wilcox) .eq. abs(wilco0)) write(6,*) 'TIED SUM'
c
c  Reduce to distinct values
c
      nprime=1
      max=n1prime+n2prime
      i=2
  672 continue
      if (data(i) .eq. data(i-1)) then
        mprime(i-1)=mprime(i)
        ymidrank(i-1)=ymidrank(i) 
        do 675 j=i,max-1 
          data(j)=data(j+1)
          midrank(j)=midrank(j+1) 
          m(j)=m(j+1) 
          mprime(j)=mprime(j+1) 
          ymidrank(j)=ymidrank(j+1) 
          xmidrank(j)=xmidrank(j+1) 
  675   continue
        max=max-1
      else
       nprime=nprime+1
       i=i+1
      endif   
      if (i .le. max) go to 672

c      if (irep .eq. 3749) then
c      write(6,*) 'ordered distinct data values= ',(data(i),i=1,nprime)
c      write(6,*) 'x multiplicities= ',(m(i),i=1,nprime)
c      write(6,*) 'y multiplicities= ',(mprime(i),i=1,nprime)
c      write(6,*) 'midrank= ',(midrank(i),i=1,nprime)
c      write(6,*) 'xmidrank=',(xmidrank(i),i=1,nprime)
c      write(6,*) 'ymidrank=',(ymidrank(i),i=1,nprime)
c      endif

c
c=========================================================
c
c  Brunner (2000) test based on estimation of treatment effect, p
c
c  Find mean rank of X's in combined sample
c  Find mean rank of Y's in combined sample
c
      mr1=0.
      mr2=0.
      do 710 i=1,nprime
        mr1=mr1+midrank(i)*real(m(i))
        mr2=mr2+midrank(i)*real(mprime(i))
  710 continue
      mr1=mr1/real(n1)
      mr2=mr2/real(n2)
c      write(6,*) 'Nonparametric est of p is for permuted data is ',
c     *               (mr1-mr2)/real(n1+n2)+.5
c      write(6,*) 'mean x rank= ',mr1
c      write(6,*) 'mean y rank= ',mr2
c
c
c  Calculate s1^2 and s2^2
      s1sq=0.
      s2sq=0.
      do 720 i=1,nprime
        s1sq=s1sq+(midrank(i)-xmidrank(i)-mr1+real(n1+1)/2.)**2*m(i)
        s2sq=s2sq+(midrank(i)-ymidrank(i)-mr2+real(n2+1)/2.)**2
     *           *mprime(i)
  720 continue
      s1sq=s1sq/real(n1-1)
      s2sq=s2sq/real(n2-1)
c      write(6,*) 's1sq= ',s1sq
c      write(6,*) 's2sq= ',s2sq


c
c  Calculate WBF, the test statistic
c
      if (s1sq+s2sq .ne. 0.0) then
        wbf1sim=(mr2-mr1)/(real(n1+n2)*sqrt(s1sq/real(n1*n2**2)
     *       +s2sq/real(n2*n1**2)))
      else
        wbf1sim=99999.
      endif

c      if (irep .eq. 3749) then
c      write(6,*) 'wbfperm= ',wbf1sim
c      endif
c
c  Use permutational null distribution to test H_0
c
      if (abs(wbf1sim) .ge. abs(wbf)) wbf1c=wbf1c+1
c
c=========================================================
c  SEMIPARAMETRIC MAXIMUM LIKELIHOOD
      if (test1d .eq. 0.0) go to 751

      fscale=1.d0
      xscale(1)=1.d0
      xscale(2)=1.d0
      x0(1)=0.d0
      x0(2)=0.d0

c
c  Maximize over lambda from -lammax to lammax
c
      mm=int(5*(lammax-lammin))+1
      likmax=-9.d99
      do 750 l=1,mm
        lambda=lammin+.2*real(l-1)
        if (abs(lambda) .le. 0.001) lambda=0.0

c        write(6,*) 'Start UMING to maximize log(likelihood)'
c        write(6,*) 'lambda=',lambda

c        lambda=1.

        call du4inf(iparam,rparam)
        rparam(5)=.0001
        call duming(loglike,grad,2,x0,xscale,fscale,iparam,rparam,
     *              xsol,fvalue)

c        write(6,*) 'Solution is (lambda,alpha,beta)'
c        write(6,*) '(',lambda,',',xsol(1),',',xsol(2),')'
c        write(6,*) 'With log(likelihood)=',-1.*fvalue
         if (-1.*fvalue .gt. likmax) then
           likmax=-1.*fvalue
           lamhat=lambda
           alphahat=xsol(1)
           betahat=xsol(2)
         endif

  750 continue
  751 continue
c      write(6,*) '1-DIM MLE Solution is (lamhat,alphahat,betahat)'
c      write(6,*) '(',lamhat,',',alphahat,',',betahat,')'
c      write(6,*) 'With log(likelihood)=',likmax
c-----------------------------
c  2-dim Model
c
c  To skip 2-DIM Model
      if (test2d .eq. 0.) go to 756

      fscale=1.d0
      xscale(1)=1.d0
      xscale(2)=1.d0
      xscale(3)=1.d0
      x0(1)=0.d0
      x0(2)=0.d0
      x0(3)=0.d0

c
c  Maximize over lambda from -lammax to lammax
c
      mm=int(5*(lammax-lammin))+1
      likmax=-9.d99
      do 755 l=1,mm
        lambda=lammin+.2*real(l-1)
        if (abs(lambda) .le. 0.001) lambda=0.0
        do 752 ll=1,mm-1
          lambd2=lammax+.2*real(ll)
          if (abs(lambd2) .le. 0.001) lambd2=0.0
  
c          lambda=1.
c          lambd2=2.

c          write(6,*) 'lambda=',lambda
c          write(6,*) 'lambd2=',lambd2
c          write(6,*) 'Start UMING to maximize log(likelihood)'
          call du4inf(iparam,rparam)
          rparam(5)=.001
          call duming(log2like,grad2,3,x0,xscale,fscale,iparam,rparam,
     *              xsol,fvalue)

c          write(6,*) 'Solution is (lambda1,lambda2,alpha,beta1,beta2)'
c          write(6,*) '(',lambda,',',lambd2,',',xsol(1),',',xsol(2),
c     *                ',',xsol(3),')'
c          write(6,*) 'With log(likelihood)=',-1.*fvalue
          if (-1.*fvalue .gt. likmax) then
            likmax=-1.*fvalue
            lam1hat=lambda
            lam2hat=lambd2
            alphat=xsol(1)
            beta1hat=xsol(2)
            beta2hat=xsol(3)
          endif
  752   continue
  755 continue
  756 continue
c      write(6,*) '2-DIM Global Sol. is (lam1,lam2,alpha,beta1,beta2)'
c      write(6,*) '(',lam1hat,',',lam2hat,',',alphat,',',beta1hat,
c     *             ',',beta2hat,')'
c      write(6,*) 'With log(likelihood)=',likmax
c
c   Calculate phat, the discrete elements of underlying distribution
c   1-dim Model
c
      do 760 i=1,n1+n2
        h(i)=(posval(i)**(lamhat)-1.)/lamhat
        zz=alphahat+betahat*(posval(i)**(lamhat)-1.)/lamhat
        if (zz .lt. 18.42) then
          thetahat(i)=exp(zz)
        else
          thetahat(i)=exp(18.42)
        endif
        phat(i)=1./(real(n2)+real(n1)*thetahat(i))
  760 continue
      sum=0.0 
      do 765 i=n1+1,n1+n2
        sum=sum+alphahat+betahat*h(i)
  765 continue
c
c   Calculate p2hat, the discrete elements of underlying distribution
c   2-dim Model
c
      do 767 i=1,n1+n2
        if (lam1hat .eq. 0. .and. lam2hat .eq. 0.) then
          h1(i)=log(posval(i))
          h2(i)=log(posval(i))
        else
          if (lam1hat .eq. 0.) then
            h1(i)=log(posval(i))
            h2(i)=(posval(i)**(lam2hat)-1.)/lam2hat
          else
            if (lam2hat .eq. 0.) then
              h1(i)=(posval(i)**(lam1hat)-1.)/lam1hat
              h2(i)=log(posval(i))
            else
              h1(i)=(posval(i)**(lam1hat)-1.)/lam1hat
              h2(i)=(posval(i)**(lam2hat)-1.)/lam2hat
            endif
          endif
        endif
        zz=alphat+beta1hat*h1(i)+beta2hat*h2(i)
        if (zz .lt. 18.42) then
          theta2h(i)=exp(zz)
        else
          theta2h(i)=exp(18.42)
        endif
        p2hat(i)=1./(real(n2)+real(n1)*theta2h(i))
c        write(6,*) 'posval()=',posval(i)
c        write(6,*) 'p2hat()=',p2hat(i)
  767 continue
      sum2=0.0 
      do 768 i=n1+1,n1+n2
        sum2=sum2+alphat+beta1hat*h1(i)+beta2hat*h2(i)
  768 continue
c
c   Order posval and make corresponding changes to phat,thetahat,p2hat,theta2h
c
      do 780 i=1,n1+n2-1
        do 770 j=i+1,n1+n2
          if (posval(j) .lt. posval(i)) then 
            temp=posval(i)
            posval(i)=posval(j) 
            posval(j)=temp
            temp=thetahat(i)
            thetahat(i)=thetahat(j) 
            thetahat(j)=temp
            temp=phat(i)
            phat(i)=phat(j) 
            phat(j)=temp
            temp=p2hat(i)
            p2hat(i)=p2hat(j) 
            p2hat(j)=temp
            temp=theta2h(i)
            theta2h(i)=theta2h(j) 
            theta2h(j)=temp
          endif
  770   continue
  780 continue
c ------------------------------------------------------------------
c  1-DIM SEMIPARAMETRIC MODEL
c
c  Calculate estimate of NBFH parameter
c
      sem1sim(isim)=0.0
      do 800 i=1,n1+n2
        temp=0.0
        do 790 j=i+1,n1+n2 
          temp=temp+phat(j)   
  790   continue
        sem1sim(isim)=sem1sim(isim)+temp*phat(i)*thetahat(i)
  800 continue
c      write(6,*) '1-DIM Semiparametric estimate of p for permuted data is ',
c     *     sem1sim(isim)
      sem1st=abs(sem1sim(isim)-.5)
c      write(6,*) 'Semiparametric test stat for permuted data is ',sem1sim
c
c  Use permutational null distribution to test H_0
c
      if (abs(sem1st) .ge. abs(semp)) sem1c=sem1c+1
c
c  Set up LRT
c
      semtlsim=0.0
      do 805 i=1,n1+n2
        semtlsim=semtlsim+log(phat(i))
  805 continue
c
c  Use LRT to test H_0
c
      semtlsim=semtlsim+sum+real(n1+n2)*log(real(n1+n2))
      semtlsim=2.*semtlsim
c      write(6,*) 'Semi-par LRT for permuted data=',semtlsim 
      
      if (semtlsim .ge. semtlrt) sem1lc=sem1lc+1
c----------------------------------------------------------------
c  SEMIPARAMETRIC MAXIMUM LIKELIHOOD (2-dim Model)
c
c  Calculate estimate of NBFH parameter P
c
      sem2psim(isim)=0.0
      do 810 i=1,n1+n2
        temp=0.0
        do 807 j=i+1,n1+n2 
          temp=temp+p2hat(j)   
  807   continue
        sem2psim(isim)=sem2psim(isim)+temp*p2hat(i)*theta2h(i)
  810 continue
c      write(6,*) '2-dim Semiparametric estimate of p is ',sem2psim(isim)
      sem2st=abs(sem2psim(isim)-.5)
c      write(6,*) '2-dim Semiparametric test statistic is ',sem2st
c
c  Use permutational null distribution to test H_0
c
      if (abs(sem2st) .ge. abs(sem2p)) sem21c=sem21c+1
c
c  Set up LRT
c
      semtlsim=0.0
      do 815 i=1,n1+n2
        semtlsim=semtlsim+log(p2hat(i))
  815 continue
c
c  Use LRT to test H_0
c
      semtlsim=semtlsim+sum+real(n1+n2)*log(real(n1+n2))
      semtlsim=2.*semtlsim
c      write(6,*) 'Semi-par LRT for permuted data=',semtlsim 
      
      if (semtlsim .ge. semt2lrt) sem21lc=sem21lc+1
c
c ----------------------------------------------------------------
c ----------------------------------------------------------------
c  To skip
      if (testlrt .eq. 0.0) go to 1000
c
c  Find restricted NMLE for permuted data
c
c
      xguess(1)=0.0
      nroot=1
      errabs=.001
      errrel=.001
      itmax=100
c      if (irep .eq. 3749) then
c      write(6,*) 'xguess=',xguess
c      endif

      call zreal(fcn,errabs,errrel,eps,eta,nroot,itmax,xguess,
     *           sol,info)

      lam1=sol(1) 

c      if (irep .eq. 3749) then
c      write(6,*) '----------------------------------------'
c      write(6,*) 'Solution from ZREAL'
c      write(6,*) 'lam1=',lam1
c      endif

      call pcalc(lam1,p,q)

c      if (irep .eq. 3749) then
c      write(6,*) '-----------------------------------------'
c      write(6,*) 'p=',(p(i),i=1,nprime)
c      write(6,*) 'q=',(q(i),i=1,nprime)
c      write(6,*) 'psum=',psum(nprime)
c      endif



c 
c  Check feasibility of solution
c
      qsum=0.0
      con3=0.0
      do 820 i=1,nprime
        qsum=qsum+q(i)
        theta=1.-psum(i)-psum(i-1)
        if (real(n2)+lam1*theta .ne. 0.0) then
          con3=con3+(1.-psum(i))*real(mprime(i))/
     *        (real(n2)+lam1*theta)
          con3=con3-real(mprime(i))*psum(i-1)/(real(n2)+lam1*theta)
        else
          con3=99999.
        endif
  820 continue

      flag=0.0
      do 822 i=1,nprime
        if (p(i) .gt. 1. .or. p(i) .lt. 0.) flag=1.0
        if (q(i) .gt. 1. .or. q(i) .lt. 0.) flag=1.0
  822 continue
      if (abs(psum(nprime)-1.0) .gt. tol) flag=1.0
      if (abs(qsum-1.0) .gt. tol) flag=1.0
      if (abs(con3) .gt. tol) flag=1.0
c  Solution feasible then bypass grid search
      if (flag .eq. 0.0) then
c        write(6,*) 'Solution from ZREAL'
c        write(6,*) 'lam1=',lam1
c        write(6,*) 'p()=',(p(i),i=1,nprime)
c        write(6,*) 'q()=',(q(i),i=1,nprime)
c        write(6,*) 'psum=',psum(nprime)
c        write(6,*) 'qsum=',qsum
c        write(6,*) 'con3',con3
         go to 980
       endif
c  Solution infeasible then do grid search for starting point
c  Search from max{mprime_1 - n_2, m_nprime - n_1} to max{(n_1-m_1)/(1-mprime_1/n_2), (n_2-mprime_nprime)/(1-m_nprime/n_1)}
c
c      if (irep .eq. 3749) then
c      write(6,*) '------------------------------'
c      write(6,*) '------------------------------'
c      write(6,*) 'First Solution infeasible'
c      write(6,*) 'Start Grid Search'
c      write(6,*) 'psum(nprime)=',psum(nprime)
c      write(6,*) 'qsum=',qsum
c      write(6,*) 'con3=',con3
c      endif
c
c   GRID SEARCH  (of increment=.1)
c
      inc=.1
      conmin=999999.

      ilowbdd=-1.*srchmul*real(n1)
      izz=-1.*srchmul*real(n2)
      if (izz .lt. ilowbdd) ilowbdd=izz
      
      iuppbdd=srchmul*real(n1)
      izz=srchmul*real(n2)
      if (izz .gt. iuppbdd) iuppbdd=izz

      do 850 i=10*ilowbdd,10*iuppbdd
        lam1=real(i)/10.
        call pcalc(lam1,p,q)
c        write(6,*) 'lam1=',lam1
c        write(6,*) 'p()=',(p(j),j=1,nprime)
        qsum=0.0
        con3=0.0
        do 840 j=1,nprime
          qsum=qsum+q(j)
          theta=1.-psum(j)-psum(j-1)
          if (real(n2)+lam1*theta .ne. 0.0) then
            con3=con3+(1.-psum(j))*real(mprime(j))/
     *          (real(n2)+lam1*theta)
            con3=con3-real(mprime(j))*psum(j-1)/(real(n2)+lam1*theta)
          else
            con3=99999.
          endif
  840   continue
c      if (irep .eq. 3749) then
c        write(6,*) 'q()=',(q(j),j=1,nprime)
c        write(6,*) 'deviation of psum=',abs(psum(nprime)-1.)
c        write(6,*) 'deviation of qsum=',abs(qsum-1.)
c        write(6,*) 'con3=',con3
c        endif
c  Check feasibility
        flag=0.0
        do 847 j=1,nprime
          if (p(j) .gt. 1. .or. p(j) .lt. 0.) flag=1.0
          if (q(j) .gt. 1. .or. q(j) .lt. 0.) flag=1.0
  847   continue
        consum=abs(con3)+abs(psum(nprime)-1.0)+abs(qsum-1.0)
c        write(6,*) 'total deviation=',consum
        if (consum .lt. conmin .and. flag .eq. 0.0) then
          conmin=consum
          lam1min=lam1
        endif
  850 continue

c      write(6,*) 'minimum from grid search occurs at lam1=',lam1min
c      write(6,*) 'sum of constraint deviations=',conmin
c
c  Start ZREAL starting at min from grid search
c
c      if (irep .eq. 3749) then
c      write(6,*) '-------------------------------------'
c      write(6,*) '-------------------------------------'
c      write(6,*) 'Start again at ',lam1min
c      endif

      xguess(1)=lam1min
      nroot=1
      errabs=.001
      errrel=.001
      itmax=100

      call zreal(fcn,errabs,errrel,eps,eta,nroot,itmax,xguess,
     *           sol,info)
      lam1=sol(1) 

c      if (irep .eq. 3749) then
c      write(6,*) '----------------------------------------'
c      write(6,*) 'Solution from ZREAL'
c      write(6,*) 'lam1=',lam1
c      endif

      call pcalc(lam1,p,q)

c      if (irep .eq. 3749) then
c      write(6,*) '-----------------------------------------'
c      write(6,*) 'p=',(p(i),i=1,nprime)
c      write(6,*) 'q=',(q(i),i=1,nprime)
c      write(6,*) 'psum=',psum(nprime)
c      endif

      qsum=0.0
      con3=0.0
      do 862 i=1,nprime
        qsum=qsum+q(i)
        theta=1.-psum(i)-psum(i-1)
        if (real(n2)+lam1*theta .ne. 0.0) then
          con3=con3+(1.-psum(i))*real(mprime(i))/
     *        (real(n2)+lam1*theta)
          con3=con3-real(mprime(i))*psum(i-1)/(real(n2)+lam1*theta)
        else
          con3=99999.
        endif
  862 continue
c      write(6,*) 'qsum=',qsum
c      write(6,*) 'con3=',con3
c 
c  Check feasibility of solution
c
      flag=0.0
      do 864 i=1,nprime
        if (p(i) .gt. 1. .or. p(i) .lt. 0.) flag=1.0
        if (q(i) .gt. 1. .or. q(i) .lt. 0.) flag=1.0
  864 continue
      if (abs(psum(nprime)-1.0) .gt. tol) flag=1.0
      if (abs(qsum-1.0) .gt. tol) flag=1.0
      if (abs(con3) .gt. tol) flag=1.0
      if (flag .eq. 0.) then
c        write(6,*) 'Solution from ZREAL'
c        write(6,*) 'lam1=',lam1
c        write(6,*) 'p()=',(p(i),i=1,nprime)
c        write(6,*) 'q()=',(q(i),i=1,nprime)
        go to 980
      endif

c  Convergence failed again, use grid search of (lam1min-.1,lam1min+.1)
c
c      if (irep .eq. 3749) then
c      write(6,*) 'Second Solution infeasible'
c      write(6,*) 'Start Grid search again near lam1min'
c      endif
c
c   GRID SEARCH  (of increment=.01)
c
      conmin=999999.
      do 875 i=1,21
        lam1=lam1min-.1+.01*real(i-1)

c        if (irep .eq. 3749) then
c        write(6,*) 'lam1=',lam1
c        endif

        call pcalc(lam1,p,q)

c        if (irep .eq. 3749) then
c        write(6,*) 'lam1=',lam1
c        write(6,*) 'p()=',(p(j),j=1,nprime)
c        endif

        qsum=0.0
        con3=0.0
        do 870 j=1,nprime
          qsum=qsum+q(j)
          theta=1.-psum(j)-psum(j-1)
          if (real(n2)+lam1*theta .ne. 0.0) then
            con3=con3+(1.-psum(j))*real(mprime(j))/
     *          (real(n2)+lam1*theta)
            con3=con3-real(mprime(j))*psum(j-1)/(real(n2)+lam1*theta)
          else
            con3=99999.
          endif
  870   continue 
c        write(6,*) 'q()=',(q(j),j=1,nprime)
c        write(6,*) 'con3=',con3
c  Check feasibility
      flag=0.0
      do 873 j=1,nprime
        if (p(j) .gt. 1. .or. p(j) .lt. 0.) flag=1.0
        if (q(j) .gt. 1. .or. q(j) .lt. 0.) flag=1.0
  873 continue
        consum=abs(con3)+abs(psum(nprime)-1.0)+abs(qsum-1.0)
        if (consum .lt. conmin .and. flag .eq. 0.0) then
          conmin=consum
          lam1m2=lam1
        endif
  875 continue
c      write(6,*) 'minimum from grid search occurs at lam1=',lam1m2
c      write(6,*) 'sum of constraint deviations=',conmin

c
c  Start ZREAL starting at min from grid search
c
c      if (irep .eq. 3749) then
c      write(6,*) '-------------------------------------'
c      write(6,*) '-------------------------------------'
c      write(6,*) 'Start again at ',lam1m2
c      endif

      xguess(1)=lam1m2
      nroot=1
      errabs=.001
      errrel=.001
      itmax=100

      call zreal(fcn,errabs,errrel,eps,eta,nroot,itmax,xguess,
     *           sol,info)

      lam1=sol(1) 
      call pcalc(lam1,p,q)
      qsum=0.0
      con3=0.0
      do 882 i=1,nprime
        qsum=qsum+q(i)
        theta=1.-psum(i)-psum(i-1)
        if (real(n2)+lam1*theta .ne. 0.0) then
          con3=con3+(1.-psum(i))*real(mprime(i))/
     *          (real(n2)+lam1*theta)
          con3=con3-real(mprime(i))*psum(i-1)/(real(n2)+lam1*theta)
        else
          con3=99999.
        endif       
  882 continue
c 
c  Check feasibility of solution
c
      flag=0.0
      do 884 i=1,nprime
        if (p(i) .gt. 1. .or. p(i) .lt. 0.) flag=1.0
        if (q(i) .gt. 1. .or. q(i) .lt. 0.) flag=1.0
  884 continue
      if (abs(psum(nprime)-1.0) .gt. tol) flag=1.0
      if (abs(qsum-1.0) .gt. tol) flag=1.0
      if (abs(con3) .gt. tol) flag=1.0
      if (flag .eq. 0.) then
c        write(6,*) 'Solution from ZREAL'
c        write(6,*) 'lam1=',lam1
c        write(6,*) 'p()=',(p(i),i=1,nprime)
c        write(6,*) 'q()=',(q(i),i=1,nprime)
        go to 980
      endif

c  Convergence failed again, use grid search of (lam1m2-.01,lam1m2+.01)
c
c      if (irep .eq. 3749) then
c      write(6,*) '-------------------------------'
c      write(6,*) '-------------------------------'
c      write(6,*) 'Third Solution infeasible'
c      write(6,*) 'Start again grid search near lam1m2'
c      write(6,*) 'psum(nprime)=',psum(nprime)
c      write(6,*) 'qsum=',qsum
c      write(6,*) 'con3=',con3
c      endif
c
c   GRID SEARCH  (of increment .001)
c
      conmin=999999.
      do 895 i=1,21
        lam1=lam1m2-.01+.001*real(i-1)

c        if (irep .eq. 3749) then
c        write(6,*) 'lam1=',lam1
c        endif

        call pcalc(lam1,p,q)

c        if (irep .eq. 3749) then
c        write(6,*) 'lam1=',lam1
c        write(6,*) 'p()=',(p(j),j=1,nprime)
c        endif 

        qsum=0.0
        con3=0.0
        do 890 j=1,nprime
          qsum=qsum+q(j)
          theta=1.-psum(j)-psum(j-1)
          if (real(n2)+lam1*theta .ne. 0.0) then
            con3=con3+(1.-psum(j))*real(mprime(j))/
     *           (real(n2)+lam1*theta)
            con3=con3-real(mprime(j))*psum(j-1)/(real(n2)+lam1*theta)
          else
            con3=99999.
          endif
  890   continue 
c        write(6,*) 'q()=',(q(j),j=1,nprime)
c        write(6,*) 'con3=',con3
c  Check feasibility
        flag=0.0
        do 893 j=1,nprime
          if (p(j) .gt. 1. .or. p(j) .lt. 0.) flag=1.0
          if (q(j) .gt. 1. .or. q(j) .lt. 0.) flag=1.0
  893   continue
        consum=abs(con3)+abs(psum(n1)-1.0)+abs(qsum-1.0)
        if (consum .lt. conmin .and. flag .eq. 0.0) then
          conmin=consum
          lam1m3=lam1
        endif
  895 continue

      lam1=lam1m3
      call pcalc(lam1,p,q)
      qsum=0.0
      con3=0.0
      do 976 j=1,nprime
        qsum=qsum+q(j)
        theta=1.-psum(j)-psum(j-1)
        if (real(n2)+lam1*theta .ne. 0.0) then
          con3=con3+(1.-psum(j))*real(mprime(j))/
     *         (real(n2)+lam1*theta)
          con3=con3-real(mprime(j))*psum(j-1)/(real(n2)+lam1*theta)
        else
          con3=99999.
        endif
  976 continue 
c 
c  Check feasibility of solution
c
      flag=0.0
      do 977 i=1,nprime
        if (p(i) .gt. 1. .or. p(i) .lt. 0.) flag=1.0
        if (q(i) .gt. 1. .or. q(i) .lt. 0.) flag=1.0
  977 continue
      if (abs(psum(nprime)-1.0) .gt. tol) flag=1.0
      if (abs(qsum-1.0) .gt. tol) flag=1.0
      if (abs(con3) .gt. tol) flag=1.0
      if (flag .eq. 0.) then
c        write(6,*) 'Solution from GRID SEARCH'
c        write(6,*) 'lam1=',lam1
c        write(6,*) 'p()=',(p(i),i=1,nprime)
c        write(6,*) 'q()=',(q(i),i=1,nprime)
        go to 980
      endif
c      write(6,*) 'No feasible solution found for permuted data'
      lrt1c=lrt1c+1
      go to 1000

c---------------------------------------------------------
c
c  Form likelhood ratio test for H_0: P{X > Y} = P{X < Y}
c
  980 continue

c      if (irep .eq. 3749) then
c      write(6,*) 'Form likelihood'
c      endif

      lrt1sim=0.0
      do 985 i=1,nprime
c        if (irep .eq. 3749) then
c        write(6,*) 'm(i)=',m(i)
c        write(6,*) 'mprime(i)=',mprime(i)
c        write(6,*) 'p(i)=',p(i)
c        write(6,*) 'q(i)=',q(i)
c        endif
        if (m(i) .ne. 0) then
          if (p(i) .ne. 0.0) then
            lrt1sim=lrt1sim+real(m(i))*log(real(m(i))
     *                    /(real(n1)*p(i)))
          else
            lrt1sim=99999.
          endif
        endif
        if (mprime(i) .ne. 0) then
          if (q(i) .ne. 0.0) then
            lrt1sim=lrt1sim+real(mprime(i))*
     *            log(real(mprime(i))/(real(n2)*q(i)))
          else
            lrt1sim=99999.
          endif
        endif
  985 continue
c      if (irep .eq. 3749) then
c      write(6,*) 'lrtperm=',lrt1sim
c      endif
      lrt1sim=2.*lrt1sim

      if (lrt1sim .ge. lrt) lrt1c=lrt1c+1

c---------------------------------------------------------
c
 1000 continue
 1001 continue
c
c  To skip simulation method
      if (testsim .eq. 0.0) go to 2001
c-----------------------------------------------------------
c-----------------------------------------------------------
c    SIMULATION FROM CONSTRAINED MLE
c  Calculate approximate null distribution from constrained mle
c
      if (nflag .eq. 1) go to 2001
      lrt2c=0
      wbf2c=0
      sem2c=0
      sem2lc=0
      sem22c=0
      sem22lc=0
      wil2c=0
      wel2c=0

      do 2000 isim=1,nsim
c        write(6,*) '-------------------------------------'
c        write(6,*) 'Sim. number',isim
c
c  Simulate data from p_0^hat
c  Recall that data0 holds the distinct ordered values
c
      call rnun(n1,rn)
      do 1510 i=1,n1
        do 1505 ii=1,n0prime
          if (rn(i) .lt. psum0(ii)) then
            xstar(i)=data0(ii)
            go to 1506
          endif 
 1505   continue
 1506   continue
 1510 continue 

c
c  Simulate data from q_0^hat
c  Recall that data0 holds the distinct ordered values
c
      call rnun(n2,rn)
      do 1520 j=1,n2
        do 1515 jj=1,n0prime
          if (rn(j) .lt. qsum0(jj)) then
            ystar(j)=data0(jj)
            go to 1516
          endif 
 1515   continue
 1516   continue
 1520 continue 
c
c  posval holds the shifted positive actual values for Box-Cox transform
c   Shift such that smallest value .5
c
      do 1525 i=1,n1+n2
        if (i .le. n1) then
          posval(i)=xstar(i)-min+.5
        else
          posval(i)=ystar(i-n1)-min+.5
        endif 
 1525 continue  
c
c      write(6,*) 'x* values= ',(xstar(i),i=1,n1)
c      write(6,*) 'y* values= ',(ystar(i),i=1,n2)
c
c  Welch t-test
c
      xbar=0.0
      do 1555 i=1,n1
        xbar=xbar+xstar(i)
 1555 continue
      xbar=xbar/real(n1)
      ybar=0.0
      do 1556 i=1,n2
        ybar=ybar+ystar(i)
 1556 continue
      ybar=ybar/real(n2)
      s1=0.0
      do 1557 i=1,n1
        s1=s1+(xstar(i)-xbar)**2
 1557 continue
      s1=s1/real(n1-1)
      s2=0.0
      do 1558 i=1,n2
        s2=s2+(ystar(i)-ybar)**2
 1558 continue
      s2=s2/real(n2-1)
      sd=s1/real(n1)+s2/real(n2)
      
      twelsim=(ybar-xbar)/sqrt(sd)
c
c  Use simulated null distribution to test H_0
c
      if (abs(twelsim) .ge. abs(twel)) wel2c=wel2c+1
c
c  Order y values among themselves
c
c  n2prime=number of distinct y values
c  mprime(i) is the multiplicity of value y_(i)
c
      do 1575 i=1,n2
        do 1570 j=i+1,n2
          if (ystar(j) .lt. ystar(i)) then
            temp=ystar(i)
            ystar(i)=ystar(j)
            ystar(j)=temp
          endif
 1570   continue
 1575 continue
c      write(6,*) 'ord. y* values= ',(ystar(i),i=1,n2)
      n2prime=1
      mprime(1)=1
      i=2
      icount=0
 1577 continue
c      write(6,*) 'n2prime= ',n2prime
      if (ystar(i) .eq. ystar(n2prime)) then 
        mprime(n2prime)=mprime(n2prime)+1
c        write(6,*) 'mprime(n2prime)= ',mprime(n2prime)
        icount=icount+1
        do 1578 j=i,n2-1
          ystar(j)=ystar(j+1)
 1578   continue
      else
        n2prime=n2prime+1
c        write(6,*) 'n2prime= ',n2prime
        mprime(n2prime)=1
c        write(6,*) 'mprime(n2prime)= ',mprime(n2prime)
        i=i+1
      endif
      if (i .lt. n2-icount+1) go to 1577
c
c  Order x values among themselves
c
c  n1prime=number of distinct x values
c  m(i) is the multiplicity of value x_(i)
c
      do 1590 i=1,n1
        do 1580 j=i+1,n1
          if (xstar(j) .lt. xstar(i)) then
            temp=xstar(i)
            xstar(i)=xstar(j)
            xstar(j)=temp
          endif
 1580   continue
 1590 continue
      n1prime=1
      m(1)=1
      i=2
      icount=0
 1592 continue
      if (xstar(i) .eq. xstar(n1prime)) then 
        m(n1prime)=m(n1prime)+1
        icount=icount+1
        do 1593 j=i,n1-1
          xstar(j)=xstar(j+1)
 1593   continue
      else
        n1prime=n1prime+1
        m(n1prime)=1
        i=i+1
      endif
      if (i .lt. n1-icount+1) go to 1592

c      write(6,*) 'distinct ord. x* values= ',(xstar(i),i=1,n1prime)
c      write(6,*) 'distinct ord. y* values= ',(ystar(i),i=1,n2prime)
c      write(6,*) 'x multiplicities= ',(m(i),i=1,n1prime)
c      write(6,*) 'y multiplicities= ',(mprime(i),i=1,n2prime)
c      write(6,*) '-------------------------------------'
c
c  Set up data to hold combined data
c  Set up xrank to hold the order statistic number if the corresponding entry of data() is a x value
c  Set up yrank to hold the order statistic number if the corresponding entry of data() is a y value
c
      do 1610 i=1,n1prime
        data(i)=xstar(i)
        yrank(i)=0
        xrank(i)=i
 1610 continue
      do 1615 i=1,n2prime
        msave(i)=mprime(i)
 1615 continue
      do 1620 i=1,n2prime
        data(n1prime+i)=ystar(i)
        yrank(n1prime+i)=i
        xrank(n1prime+i)=0
        m(n1prime+i)=0
        mprime(n1prime+i)=msave(i)
 1620 continue
      do 1625 i=1,n1prime
        mprime(i)=0
 1625 continue
c      write(6,*) 'data values= ',(data(i),i=1,n1prime+n2prime)
c      write(6,*) 'x multiplicities= ',(m(i),i=1,n1prime+n2prime)
c      write(6,*) 'y multiplicities= ',(mprime(i),i=1,n1prime+n2prime)
c
c  Order the combined values
c
      do 1650 i=1,n1prime+n2prime-1
        do 1640 j=i+1,n1prime+n2prime
          if (data(j) .lt. data(i)) then
            temp=data(i)
            temp2=xrank(i)
            temp3=yrank(i)
            temp4=m(i)
            temp5=mprime(i)
            data(i)=data(j)
            xrank(i)=xrank(j)
            yrank(i)=yrank(j)
            m(i)=m(j)
            mprime(i)=mprime(j)
            data(j)=temp
            xrank(j)=temp2
            yrank(j)=temp3
            m(j)=temp4
            mprime(j)=temp5
          endif
 1640   continue
 1650 continue
c      write(6,*) 'ordered data values= ',(data(i),i=1,n1prime+n2prime)
c      write(6,*) 'x multiplicities= ',(m(i),i=1,n1prime+n2prime)
c      write(6,*) 'y multiplicities= ',(mprime(i),i=1,n1prime+n2prime)
c
c  Set up samcount(i) to give the combined ordered sample less than data(i)
c
      sumyrank=0.
      samcount(1)=0
      ysamc=0
      xsamc=0
      do 1670 i=1,n1prime+n2prime
        if (yrank(i) .ne. 0) then
          midrank(i)=0.0
          do 1660 j=samcount(i)+1,samcount(i)+mprime(i)
            midrank(i)=midrank(i)+real(j)
 1660     continue
          ymidrank(i)=0.0
          do 1661 j=ysamc+1,ysamc+mprime(i)
            ymidrank(i)=ymidrank(i)+real(j)
 1661     continue
          ymidrank(i)=ymidrank(i)/real(mprime(i))
          ysamc=ysamc+mprime(i)
          midden=mprime(i)
          if (i .ne. 1) then
            if (data(i) .eq. data(i-1)) then
              do 1662 j=samcount(i-1)+1,samcount(i-1)+m(i-1)
                midrank(i)=midrank(i)+real(j)
 1662         continue
              midden=midden+m(i-1)
            endif
          endif
          midrank(i)=midrank(i)/real(midden)
          samcount(i+1)=samcount(i)+mprime(i)
          sumyrank=sumyrank+midrank(i)*real(mprime(i))
        endif
        if (xrank(i) .ne. 0) then
          midrank(i)=0.0
          do 1665 j=samcount(i)+1,samcount(i)+m(i)
            midrank(i)=midrank(i)+real(j)
 1665     continue
          xmidrank(i)=0.0
          do 1666 j=xsamc+1,xsamc+m(i)
            xmidrank(i)=xmidrank(i)+real(j)
 1666     continue
          xmidrank(i)=xmidrank(i)/real(m(i))
          xsamc=xsamc+m(i)
          midden=m(i)
          samcount(i+1)=samcount(i)+m(i)
          if (i .ne. n1prime+n2prime) then
            if (data(i) .eq. data(i+1)) then
              do 1667 j=samcount(i+1)+1,samcount(i+1)+mprime(i+1)
                midrank(i)=midrank(i)+real(j)
 1667         continue
              midden=midden+mprime(i+1)
            endif
          endif
          midrank(i)=midrank(i)/real(midden)
        endif
 1670 continue
c      write(6,*) 'midrank= ',(midrank(i),i=1,n1prime+n2prime)
c      write(6,*) 'sumyrank= ',sumyrank
c      write(6,*) 'xmidrank=',(xmidrank(i),i=1,n1prime+n2prime)
c      write(6,*) 'ymidrank=',(ymidrank(i),i=1,n1prime+n2prime)
c
c  Wilcoxon Rank Sum Test
c
c  Use Sim. NMLE null distribution to test H_0
c
      wilcox=sumyrank-.5*real(n2)*real(n1+n2+1)
      wilcox=wilcox*sqrt(12.)/sqrt(real(n1*n2)*real(n1+n2+1))
      if (abs(wilcox) .ge. abs(wilco0)) wil2c=wil2c+1
c
c  Reduce to distinct values
c
      nprime=1
      max=n1prime+n2prime
      i=2
 1672 continue
      if (data(i) .eq. data(i-1)) then
        mprime(i-1)=mprime(i)
        ymidrank(i-1)=ymidrank(i) 
        do 1675 j=i,max-1 
          data(j)=data(j+1)
          midrank(j)=midrank(j+1) 
          m(j)=m(j+1) 
          mprime(j)=mprime(j+1) 
          ymidrank(j)=ymidrank(j+1) 
          xmidrank(j)=xmidrank(j+1) 
 1675   continue
        max=max-1
      else
       nprime=nprime+1
       i=i+1
      endif   
      if (i .le. max) go to 1672

c      if (irep .eq. 3749) then
c      write(6,*) 'ordered distinct data values= ',(data(i),i=1,nprime)
c      write(6,*) 'x multiplicities= ',(m(i),i=1,nprime)
c      write(6,*) 'y multiplicities= ',(mprime(i),i=1,nprime)
c      write(6,*) 'midrank= ',(midrank(i),i=1,nprime)
c      write(6,*) 'xmidrank=',(xmidrank(i),i=1,nprime)
c      write(6,*) 'ymidrank=',(ymidrank(i),i=1,nprime)
c      endif

c
c=========================================================
c
c  Brunner (2000) test based on estimation of treatment effect, p
c
c  Find mean rank of X's in combined sample
c  Find mean rank of Y's in combined sample
c
      mr1=0.
      mr2=0.
      do 1710 i=1,nprime
        mr1=mr1+midrank(i)*real(m(i))
        mr2=mr2+midrank(i)*real(mprime(i))
 1710 continue
      mr1=mr1/real(n1)
      mr2=mr2/real(n2)
c      write(6,*) 'Nonparametric est of p is for simulated data is ',
c     *               (mr1-mr2)/real(n1+n2)+.5
c      write(6,*) 'mean x rank= ',mr1
c      write(6,*) 'mean y rank= ',mr2
c
c
c  Calculate s1^2 and s2^2
      s1sq=0.
      s2sq=0.
      do 1720 i=1,nprime
        s1sq=s1sq+(midrank(i)-xmidrank(i)-mr1+real(n1+1)/2.)**2*m(i)
        s2sq=s2sq+(midrank(i)-ymidrank(i)-mr2+real(n2+1)/2.)**2
     *           *mprime(i)
 1720 continue
      s1sq=s1sq/real(n1-1)
      s2sq=s2sq/real(n2-1)

c      write(6,*) 's1sq= ',s1sq
c      write(6,*) 's2sq= ',s2sq

c
c  Calculate WBF, the test statistic
c
      if (s1sq+s2sq .ne. 0.0) then
        wbf2sim=(mr2-mr1)/(real(n1+n2)*sqrt(s1sq/real(n1*n2**2)
     *       +s2sq/real(n2*n1**2)))
      else
        wbf2sim=99999.
      endif
c      write(6,*) 'wbfperm= ',wbf2sim
c
c  Use permutational null distribution to test H_0
c
      if (abs(wbf2sim) .ge. abs(wbf)) wbf2c=wbf2c+1
c
c=========================================================
c  SEMIPARAMETRIC MAXIMUM LIKELIHOOD
c 1-DIM Model
      if (test1d .eq. 0.0) go to 1751

      fscale=1.d0
      xscale(1)=1.d0
      xscale(2)=1.d0
      x0(1)=0.d0
      x0(2)=0.d0

c
c  Maximize over lambda from -lammax to lammax
c
      mm=int(5*(lammax-lammin))+1
      likmax=-9.d99
      do 1750 l=1,mm
        lambda=lammin+.2*real(l-1)
        if (abs(lambda) .le. 0.001) lambda=0.0

c        lambda=1.

c        write(6,*) 'Start UMING to maximize log(likelihood)'
        call du4inf(iparam,rparam)
        rparam(5)=.0001
        call duming(loglike,grad,2,x0,xscale,fscale,iparam,rparam,
     *              xsol,fvalue)

c        write(6,*) '1-DIM Solution is (lambda,alpha,beta)'
c        write(6,*) '(',lambda,',',xsol(1),',',xsol(2),')'
c        write(6,*) 'With log(likelihood)=',-1.*fvalue
         if (-1.*fvalue .gt. likmax) then
           likmax=-1.*fvalue
           lamhat=lambda
           alphahat=xsol(1)
           betahat=xsol(2)
         endif

 1750 continue
 1751 continue
c      write(6,*) '1-DIM MLE Solution is (lamhat,alphahat,betahat)'
c      write(6,*) '(',lamhat,',',alphahat,',',betahat,')'
c      write(6,*) 'With log(likelihood)=',likmax
c-----------------------------
c  2-dim Model
c
c  To skip 2-DIM Model
      if (test2d .eq. 0.0) go to 1756

      fscale=1.d0
      xscale(1)=1.d0
      xscale(2)=1.d0
      xscale(3)=1.d0
      x0(1)=0.d0
      x0(2)=0.d0
      x0(3)=0.d0

c
c  Maximize over lambda from -lammax to lammax
c
      mm=int(5*(lammax-lammin))+1
      likmax=-9.d99
      do 1755 l=1,mm
        lambda=lammin+.2*real(l-1)
        if (abs(lambda) .le. 0.001) lambda=0.0
        do 1752 ll=1,mm-1
          lambd2=lammax+.2*real(ll)
          if (abs(lambd2) .le. 0.001) lambd2=0.0
  
c          lambda=1.
c          lambd2=2.

c          write(6,*) 'lambda=',lambda
c          write(6,*) 'lambd2=',lambd2
c          write(6,*) 'Start UMING to maximize log(likelihood)'
          call du4inf(iparam,rparam)
          rparam(5)=.001
          call duming(log2like,grad2,3,x0,xscale,fscale,iparam,rparam,
     *              xsol,fvalue)

c          write(6,*) 'Solution is (lambda1,lambda2,alpha,beta1,beta2)'
c          write(6,*) '(',lambda,',',lambd2,',',xsol(1),',',xsol(2),
c     *                ',',xsol(3),')'
c          write(6,*) 'With log(likelihood)=',-1.*fvalue
          if (-1.*fvalue .gt. likmax) then
            likmax=-1.*fvalue
            lam1hat=lambda
            lam2hat=lambd2
            alphat=xsol(1)
            beta1hat=xsol(2)
            beta2hat=xsol(3)
          endif
 1752   continue
 1755 continue
 1756 continue
c      write(6,*) '2-DIM Global Sol. is (lam1,lam2,alpha,beta1,beta2)'
c      write(6,*) '(',lam1hat,',',lam2hat,',',alphat,',',beta1hat,
c     *             ',',beta2hat,')'
c      write(6,*) 'With log(likelihood)=',likmax
c
c   Calculate phat, the discrete elements of underlying distribution
c   1-DIM Model
c
      do 1760 i=1,n1+n2
        if (lamhat .eq. 0.0) then
          h(i)=log(posval(i))
          zz=alphahat+betahat*log(posval(i))
        else
          h(i)=(posval(i)**(lamhat)-1.)/lamhat
          zz=alphahat+betahat*(posval(i)**(lamhat)-1.)/lamhat
        endif
        if (zz .lt. 18.42) then
          thetahat(i)=exp(zz)
        else
          thetahat(i)=exp(18.42)
        endif
        phat(i)=1./(real(n2)+real(n1)*thetahat(i))
c        write(6,*) 'posval()=',posval(i)
c        write(6,*) 'phat()=',phat(i)
 1760 continue
      sum=0.0 
      do 1765 i=n1+1,n1+n2
        sum=sum+alphahat+betahat*h(i)
 1765 continue
c
c   Calculate p2hat, the discrete elements of underlying distribution
c   2-dim Model
c
      do 1767 i=1,n1+n2
        if (lam1hat .eq. 0. .and. lam2hat .eq. 0.) then
          h1(i)=log(posval(i))
          h2(i)=log(posval(i))
        else
          if (lam1hat .eq. 0.) then
            h1(i)=log(posval(i))
            h2(i)=(posval(i)**(lam2hat)-1.)/lam2hat
          else
            if (lam2hat .eq. 0.) then
              h1(i)=(posval(i)**(lam1hat)-1.)/lam1hat
              h2(i)=log(posval(i))
            else
              h1(i)=(posval(i)**(lam1hat)-1.)/lam1hat
              h2(i)=(posval(i)**(lam2hat)-1.)/lam2hat
            endif
          endif
        endif
        zz=alphat+beta1hat*h1(i)+beta2hat*h2(i)
        if (zz .lt. 18.42) then
          theta2h(i)=exp(zz)
        else
          theta2h(i)=exp(18.42)
        endif
        p2hat(i)=1./(real(n2)+real(n1)*theta2h(i))
c        write(6,*) 'posval()=',posval(i)
c        write(6,*) 'p2hat()=',p2hat(i)
 1767 continue
      sum2=0.0 
      do 1768 i=n1+1,n1+n2
        sum2=sum2+alphat+beta1hat*h1(i)+beta2hat*h2(i)
 1768 continue
c      write(6,*) 'sum log(theta2h) over second group =',sum2
c
c   Order posval and make corresponding changes to phat,thetahat,p2hat,theta2h
c
      do 1780 i=1,n1+n2-1
        do 1770 j=i+1,n1+n2
          if (posval(j) .lt. posval(i)) then 
            temp=posval(i)
            posval(i)=posval(j) 
            posval(j)=temp
            temp=thetahat(i)
            thetahat(i)=thetahat(j) 
            thetahat(j)=temp
            temp=phat(i)
            phat(i)=phat(j) 
            phat(j)=temp
            temp=p2hat(i)
            p2hat(i)=p2hat(j) 
            p2hat(j)=temp
            temp=theta2h(i)
            theta2h(i)=theta2h(j) 
            theta2h(j)=temp
          endif
 1770   continue
 1780 continue
c-----------------------------------------------------------------
c  SEMIPARAMETRIC MAXIMUM LIKELIHOOD (1-dim Model)
c
c
c  Calculate estimate of NBFH parameter
c
      sem2sim(isim)=0.0
      do 1800 i=1,n1+n2
        temp=0.0
        do 1790 j=i+1,n1+n2 
          temp=temp+phat(j)   
 1790   continue
        sem2sim(isim)=sem2sim(isim)+temp*phat(i)*thetahat(i)
 1800 continue
c      write(6,*) 'Semiparametric estimate of p for simulated data is ',
c     *             sem2sim(isim)
      sem1st=abs(sem2sim(isim)-.5)
c      write(6,*) 'Semiparametric t.s. for simulated data is ',sem2sim
c
c  Use simulated null distribution to test H_0
c
      if (abs(sem1st) .ge. abs(semp)) sem2c=sem2c+1
c
c  Set up LRT
c
      semtlsim=0.0
      do 1805 i=1,n1+n2
        semtlsim=semtlsim+log(phat(i))
 1805 continue
c
c  Use LRT to test H_0
c
      semtlsim=semtlsim+sum+real(n1+n2)*log(real(n1+n2))
      semtlsim=2.*semtlsim
c      write(6,*) 'Semi-par LRT for simulated data=',semtlsim 
      
      if (semtlsim .ge. semtlrt) sem2lc=sem2lc+1
c
c-----------------------------------------------------------------
c  SEMIPARAMETRIC MAXIMUM LIKELIHOOD (2-dim Model)
c
c
c  Calculate estimate of NBFH parameter
c
      sem22sim(isim)=0.0
      do 1810 i=1,n1+n2
        temp=0.0
        do 1807 j=i+1,n1+n2 
          temp=temp+p2hat(j)   
 1807   continue
        sem22sim(isim)=sem22sim(isim)+temp*p2hat(i)*theta2h(i)
 1810 continue
c      write(6,*) 'Semiparametric estimate of p for simulated data is ',
c     *             sem22sim(isim)
      sem2st=abs(sem22sim(isim)-.5)
c      write(6,*) 'Semiparametric t.s. for simulated data is ',sem2st
c
c  Use simulated null distribution to test H_0
c
      if (abs(sem2st) .ge. abs(sem2p)) sem22c=sem22c+1
c      write(6,*) 'Simulated 2-dim Semip ts is ',sem22sim
c
c  Set up LRT
c
      semtlsim=0.0
      do 1815 i=1,n1+n2
        semtlsim=semtlsim+log(p2hat(i))
 1815 continue
c
c  Use LRT to test H_0
c
      semtlsim=semtlsim+sum2+real(n1+n2)*log(real(n1+n2))
      semtlsim=2.*semtlsim
c      write(6,*) 'Semi-par LRT for permuted data=',semtlsim 
      
      if (semtlsim .ge. semt2lrt) sem22lc=sem22lc+1
c=========================================================
c  To skip GMLE on simulated data
      if (testlrt .eq. 0.) go to 2000
c
c  Find restricted MLE for simulated data
c
c
      xguess(1)=0.0
      nroot=1
      errabs=.001
      errrel=.001
      itmax=100

c      if (irep .eq. 3749) then
c      write(6,*) 'xguess=',xguess
c      endif

      call zreal(fcn,errabs,errrel,eps,eta,nroot,itmax,xguess,
     *           sol,info)

      lam1=sol(1) 

c      if (irep .eq. 3749) then
c      write(6,*) '----------------------------------------'
c      write(6,*) 'Solution from ZREAL'
c      write(6,*) 'lam1=',lam1
c      endif

      call pcalc(lam1,p,q)

c      if (irep .eq. 3749) then
c      write(6,*) '-----------------------------------------'
c      write(6,*) 'p=',(p(i),i=1,nprime)
c      write(6,*) 'q=',(q(i),i=1,nprime)
c      write(6,*) 'psum=',psum(nprime)
c      endif



c 
c  Check feasibility of solution
c
      qsum=0.0
      con3=0.0
      do 1820 i=1,nprime
        qsum=qsum+q(i)
        theta=1.-psum(i)-psum(i-1)
        if (real(n2)+lam1*theta .ne. 0.0) then
          con3=con3+(1.-psum(i))*real(mprime(i))/
     *        (real(n2)+lam1*theta)
          con3=con3-real(mprime(i))*psum(i-1)/(real(n2)+lam1*theta)
        else
          con3=99999.
        endif
 1820 continue

      flag=0.0
      do 1822 i=1,nprime
        if (p(i) .gt. 1. .or. p(i) .lt. 0.) flag=1.0
        if (q(i) .gt. 1. .or. q(i) .lt. 0.) flag=1.0
 1822 continue
      if (abs(psum(nprime)-1.0) .gt. tol) flag=1.0
      if (abs(qsum-1.0) .gt. tol) flag=1.0
      if (abs(con3) .gt. tol) flag=1.0
c  Solution feasible then bypass grid search
      if (flag .eq. 0.0) then
c        write(6,*) 'Solution from ZREAL'
c        write(6,*) 'lam1=',lam1
c        write(6,*) 'p()=',(p(i),i=1,nprime)
c        write(6,*) 'q()=',(q(i),i=1,nprime)
c        write(6,*) 'psum=',psum(nprime)
c        write(6,*) 'qsum=',qsum
c        write(6,*) 'con3',con3
         go to 1980
       endif
c  Solution infeasible then do grid search for starting point
c  Search from max{mprime_1 - n_2, m_nprime - n_1} to max{(n_1-m_1)/(1-mprime_1/n_2), (n_2-mprime_nprime)/(1-m_nprime/n_1)}
c
c      if (irep .eq. 3749) then
c      write(6,*) '------------------------------'
c      write(6,*) '------------------------------'
c      write(6,*) 'First Solution infeasible'
c      write(6,*) 'Start Grid Search'
c      write(6,*) 'psum(nprime)=',psum(nprime)
c      write(6,*) 'qsum=',qsum
c      write(6,*) 'con3=',con3
c      endif
c
c   GRID SEARCH  (of increment=.1)
c
      inc=.1
      conmin=999999.

      ilowbdd=-1.*srchmul*real(n1)
      izz=-1.*srchmul*real(n2)
      if (izz .lt. ilowbdd) ilowbdd=izz
      
      iuppbdd=srchmul*real(n1)
      izz=srchmul*real(n2)
      if (izz .gt. iuppbdd) iuppbdd=izz

      do 1850 i=10*ilowbdd,10*iuppbdd
        lam1=real(i)/10.
        call pcalc(lam1,p,q)
c        write(6,*) 'lam1=',lam1
c        write(6,*) 'p()=',(p(j),j=1,nprime)
        qsum=0.0
        con3=0.0
        do 1840 j=1,nprime
          qsum=qsum+q(j)
          theta=1.-psum(j)-psum(j-1)
          if (real(n2)+lam1*theta .ne. 0.0) then
            con3=con3+(1.-psum(j))*real(mprime(j))/
     *          (real(n2)+lam1*theta)
            con3=con3-real(mprime(j))*psum(j-1)/(real(n2)+lam1*theta)
          else
            con3=99999.
          endif
 1840   continue
c        write(6,*) 'q()=',(q(j),j=1,nprime)
c        write(6,*) 'deviation of psum=',abs(psum(nprime)-1.)
c        write(6,*) 'deviation of qsum=',abs(qsum-1.)
c        write(6,*) 'con3=',con3
c  Check feasibility
        flag=0.0
        do 1847 j=1,nprime
          if (p(j) .gt. 1. .or. p(j) .lt. 0.) flag=1.0
          if (q(j) .gt. 1. .or. q(j) .lt. 0.) flag=1.0
 1847   continue
        consum=abs(con3)+abs(psum(nprime)-1.0)+abs(qsum-1.0)
c        write(6,*) 'total deviation=',consum
        if (consum .lt. conmin .and. flag .eq. 0.0) then
          conmin=consum
          lam1min=lam1
        endif
 1850 continue

c      write(6,*) 'minimum from grid search occurs at lam1=',lam1min
c      write(6,*) 'sum of constraint deviations=',conmin
c
c  Start ZREAL starting at min from grid search
c
c      if (irep .eq. 621 .and. isim .eq. 74) then
c      write(6,*) '-------------------------------------'
c      write(6,*) '-------------------------------------'
c      write(6,*) 'Start again at ',lam1min
c      endif
      xguess(1)=lam1min
      nroot=1
      errabs=.001
      errrel=.001
      itmax=100

      call zreal(fcn,errabs,errrel,eps,eta,nroot,itmax,xguess,
     *           sol,info)
      lam1=sol(1) 

c      write(6,*) '----------------------------------------'
c      write(6,*) 'Solution from ZREAL'
c      write(6,*) 'lam1=',lam1
      call pcalc(lam1,p,q)
c      write(6,*) '-----------------------------------------'
c      write(6,*) 'p=',(p(i),i=1,nprime)
c      write(6,*) 'q=',(q(i),i=1,nprime)
c      write(6,*) 'psum=',psum(nprime)

      qsum=0.0
      con3=0.0
      do 1862 i=1,nprime
        qsum=qsum+q(i)
        theta=1.-psum(i)-psum(i-1)
        if (real(n2)+lam1*theta .ne. 0.0) then
          con3=con3+(1.-psum(i))*real(mprime(i))/
     *        (real(n2)+lam1*theta)
          con3=con3-real(mprime(i))*psum(i-1)/(real(n2)+lam1*theta)
        else
          con3=99999.
        endif
 1862 continue
c      write(6,*) 'qsum=',qsum
c      write(6,*) 'con3=',con3
c 
c  Check feasibility of solution
c
      flag=0.0
      do 1864 i=1,nprime
        if (p(i) .gt. 1. .or. p(i) .lt. 0.) flag=1.0
        if (q(i) .gt. 1. .or. q(i) .lt. 0.) flag=1.0
 1864 continue
      if (abs(psum(nprime)-1.0) .gt. tol) flag=1.0
      if (abs(qsum-1.0) .gt. tol) flag=1.0
      if (abs(con3) .gt. tol) flag=1.0
      if (flag .eq. 0.) then
c        write(6,*) 'Solution from ZREAL'
c        write(6,*) 'lam1=',lam1
c        write(6,*) 'p()=',(p(i),i=1,nprime)
c        write(6,*) 'q()=',(q(i),i=1,nprime)
        go to 1980
      endif

c  Convergence failed again, use grid search of (lam1min-.1,lam1min+.1)
c
c      if (irep .eq. 621 .and. isim .eq. 74) then
c      write(6,*) 'Second Solution infeasible'
c      write(6,*) 'Start Grid search again near lam1min'
c      endif
c
c   GRID SEARCH  (of increment=.01)
c
      conmin=999999.
      do 1875 i=1,21
        lam1=lam1min-.1+.01*real(i-1)
        call pcalc(lam1,p,q)
c        write(6,*) 'lam1=',lam1
c        write(6,*) 'p()=',(p(j),j=1,nprime)
        qsum=0.0
        con3=0.0
        do 1870 j=1,nprime
          qsum=qsum+q(j)
          theta=1.-psum(j)-psum(j-1)
          if (real(n2)+lam1*theta .ne. 0.0) then
            con3=con3+(1.-psum(j))*real(mprime(j))/
     *          (real(n2)+lam1*theta)
            con3=con3-real(mprime(j))*psum(j-1)/(real(n2)+lam1*theta)
          else
            con3=99999.
          endif
 1870   continue 
c        write(6,*) 'q()=',(q(j),j=1,nprime)
c        write(6,*) 'con3=',con3
c  Check feasibility
      flag=0.0
      do 1873 j=1,nprime
        if (p(j) .gt. 1. .or. p(j) .lt. 0.) flag=1.0
        if (q(j) .gt. 1. .or. q(j) .lt. 0.) flag=1.0
 1873 continue
        consum=abs(con3)+abs(psum(nprime)-1.0)+abs(qsum-1.0)
        if (consum .lt. conmin .and. flag .eq. 0.0) then
          conmin=consum
          lam1m2=lam1
        endif
 1875 continue
c      write(6,*) 'minimum from grid search occurs at lam1=',lam1m2
c      write(6,*) 'sum of constraint deviations=',conmin

c
c  Start ZREAL starting at min from grid search
c
c      if (irep .eq. 621 .and. isim .eq. 74) then
c      write(6,*) '-------------------------------------'
c      write(6,*) '-------------------------------------'
c      write(6,*) 'Start again at ',lam1m2
c      endif

      xguess(1)=lam1m2
      nroot=1
      errabs=.001
      errrel=.001
      itmax=100

      call zreal(fcn,errabs,errrel,eps,eta,nroot,itmax,xguess,
     *           sol,info)

      lam1=sol(1) 
      call pcalc(lam1,p,q)
      qsum=0.0
      con3=0.0
      do 1882 i=1,nprime
        qsum=qsum+q(i)
        theta=1.-psum(i)-psum(i-1)
        if (real(n2)+lam1*theta .ne. 0.0) then
          con3=con3+(1.-psum(i))*real(mprime(i))/
     *          (real(n2)+lam1*theta)
          con3=con3-real(mprime(i))*psum(i-1)/(real(n2)+lam1*theta)
        else
          con3=99999.
        endif       
 1882 continue
c 
c  Check feasibility of solution
c
      flag=0.0
      do 1884 i=1,nprime
        if (p(i) .gt. 1. .or. p(i) .lt. 0.) flag=1.0
        if (q(i) .gt. 1. .or. q(i) .lt. 0.) flag=1.0
 1884 continue
      if (abs(psum(nprime)-1.0) .gt. tol) flag=1.0
      if (abs(qsum-1.0) .gt. tol) flag=1.0
      if (abs(con3) .gt. tol) flag=1.0
      if (flag .eq. 0.) then
c        write(6,*) 'Solution from ZREAL'
c        write(6,*) 'lam1=',lam1
c        write(6,*) 'p()=',(p(i),i=1,nprime)
c        write(6,*) 'q()=',(q(i),i=1,nprime)
        go to 1980
      endif

c  Convergence failed again, use grid search of (lam1m2-.01,lam1m2+.01)
c
c      if (irep .eq. 621 .and. isim .eq. 74) then
c      write(6,*) '-------------------------------'
c      write(6,*) '-------------------------------'
c      write(6,*) 'Third Solution infeasible'
c      write(6,*) 'Start again grid search near lam1m2'
c      write(6,*) 'psum(nprime)=',psum(nprime)
c      write(6,*) 'qsum=',qsum
c      write(6,*) 'con3=',con3
c      endif
c
c   GRID SEARCH  (of increment .001)
c
      conmin=999999.
      do 1895 i=1,21
        lam1=lam1m2-.01+.001*real(i-1)
        call pcalc(lam1,p,q)
c        write(6,*) 'lam1=',lam1
c        write(6,*) 'p()=',(p(j),j=1,nprime)
        qsum=0.0
        con3=0.0
        do 1890 j=1,nprime
          qsum=qsum+q(j)
          theta=1.-psum(j)-psum(j-1)
          if (real(n2)+lam1*theta .ne. 0.0) then
            con3=con3+(1.-psum(j))*real(mprime(j))/
     *           (real(n2)+lam1*theta)
            con3=con3-real(mprime(j))*psum(j-1)/(real(n2)+lam1*theta)
          else
            con3=99999.
          endif
 1890   continue 
c        write(6,*) 'q()=',(q(j),j=1,nprime)
c        write(6,*) 'con3=',con3
c  Check feasibility
        flag=0.0
        do 1893 j=1,nprime
          if (p(j) .gt. 1. .or. p(j) .lt. 0.) flag=1.0
          if (q(j) .gt. 1. .or. q(j) .lt. 0.) flag=1.0
 1893   continue
        consum=abs(con3)+abs(psum(n1)-1.0)+abs(qsum-1.0)
        if (consum .lt. conmin .and. flag .eq. 0.0) then
          conmin=consum
          lam1m3=lam1
        endif
 1895 continue

      lam1=lam1m3
      call pcalc(lam1,p,q)
      qsum=0.0
      con3=0.0
      do 1976 j=1,nprime
        qsum=qsum+q(j)
        theta=1.-psum(j)-psum(j-1)
        if (real(n2)+lam1*theta .ne. 0.0) then
          con3=con3+(1.-psum(j))*real(mprime(j))/
     *         (real(n2)+lam1*theta)
          con3=con3-real(mprime(j))*psum(j-1)/(real(n2)+lam1*theta)
        else
          con3=99999.
        endif
 1976 continue 
c 
c  Check feasibility of solution
c
      flag=0.0
      do 1977 i=1,nprime
        if (p(i) .gt. 1. .or. p(i) .lt. 0.) flag=1.0
        if (q(i) .gt. 1. .or. q(i) .lt. 0.) flag=1.0
 1977 continue
      if (abs(psum(nprime)-1.0) .gt. tol) flag=1.0
      if (abs(qsum-1.0) .gt. tol) flag=1.0
      if (abs(con3) .gt. tol) flag=1.0
      if (flag .eq. 0.) then
c        write(6,*) 'Solution from GRID SEARCH'
c        write(6,*) 'lam1=',lam1
c        write(6,*) 'p()=',(p(i),i=1,nprime)
c        write(6,*) 'q()=',(q(i),i=1,nprime)
        go to 1980
      endif
c      if (irep .eq. 621 .and. isim .eq. 74) then
c      write(6,*) 'No feasible solution found for permuted data'
c      endif
c      nofeas=nofeas+1
      lrt2c=lrt2c+1
      wbf2c=wbf2c+1
      sem2c=sem2c+1
      sem22c=sem22c+1
      wel2c=wel2c+1
      wil2c=wil2c+1
      go to 2000

c---------------------------------------------------------
c
c  Form likelhood ratio test for H_0: P{X > Y} = P{X < Y}
c
 1980 continue
      lrt2sim=0.0
      do 1985 i=1,nprime
        if (m(i) .ne. 0) then
          if (p(i) .ne. 0.0) then
            lrt2sim=lrt2sim+real(m(i))*log(real(m(i))
     *                    /(real(n1)*p(i)))
          else
            lrt2sim=99999.
          endif
        endif
        if (mprime(i) .ne. 0) then
          if (q(i) .ne. 0.0) then
            lrt2sim=lrt2sim+real(mprime(i))*
     *            log(real(mprime(i))/(real(n2)*q(i)))
          else
            lrt2sim=99999.
          endif   
        endif
 1985 continue
c      write(6,*) 'lrtperm=',lrt2sim
      lrt2sim=2.*lrt2sim
      if (lrt2sim .ge. lrt) lrt2c=lrt2c+1

c---------------------------------------------------------
c
 2000 continue
 2001 continue
      pow1wel=real(wel1c+1)/real(nsim+1)
      pow2wel=real(wel2c+1)/real(nsim+1)
      pow1wil=real(wil1c+1)/real(nsim+1)
      pow2wil=real(wil2c+1)/real(nsim+1)
      pow1br=real(wbf1c+1)/real(nsim+1)
      pow2br=real(wbf2c+1)/real(nsim+1)
      pow1lrt=real(lrt1c+1)/real(nsim+1)
      pow2lrt=real(lrt2c+1)/real(nsim+1)
      pow1sem=real(sem1c+1)/real(nsim+1)
      pow2sem=real(sem2c+1)/real(nsim+1)
      pow21sem=real(sem21c+1)/real(nsim+1)
      pow22sem=real(sem22c+1)/real(nsim+1)
      pow22lse=real(sem22lc+1)/real(nsim+1)
      pow2lsem=real(sem2lc+1)/real(nsim+1)
      pow1lsem=real(sem1lc+1)/real(nsim+1)
c
      p1bar=0.0
      p2bar=0.0
      do 2100 isim=1,nsim
        p1bar=p1bar+sem2sim(isim)
        p2bar=p2bar+sem22sim(isim)
 2100 continue
      p1bar=p1bar/real(nsim)
      p2bar=p2bar/real(nsim)

      s1=0.0
      s2=0.0
      do 2110 isim=1,nsim
        s1=s1+(sem2sim(isim)-p1bar)**2
        s2=s2+(sem22sim(isim)-p2bar)**2
 2110 continue
      s1=sqrt(s1/real(nsim-1))
      s2=sqrt(s2/real(nsim-1))
c      write(6,*) 'Estimated SD under Null for phat by SEM1=',s1
c      write(6,*) 'Estimated SD under Null for phat by SEM2=',s2
c
c
c
c  Write Results
c
      write(6,*) 'P-values of Tests of Nonparametric Behrens-Fisher'
      write(6,*) 'Hypothesis: P( X > Y ) = P( X < Y )'
      write(6,*) 'No feasible MLE found ',nofeas,' times '
      write(6,*) '----------------------------------------------'
      write(6,*) 'sample sizes =(',n1,' , ',n2,' )'
      write(6,*) 'Data Set=',infile
      write(6,*) 'number of random perms for null dist=',nsim
      write(6,*) 'Maximum lambda, the 1D Box-Cox parameter =',lammax
      write(6,*) 'Maximum lambd2, the 2D Box-Cox parameter =',lam2max
      write(6,*) '----------------------------------------------'
      write(6,*) '----------------------------------------------'
      if (testperm .ne. 0.0) then 
        write(6,*) 'Using permutation null distribution'
        write(6,*) 'P-value of ELRT=',pow1lrt
        write(6,*) 'P-value of Brunner Test=',pow1br
        if (test1d .ne. 0.0) then
          write(6,*) 'P-value of 1D Semi est. of p Test=',pow1sem
c          write(6,*) 'P-value of 1D Semi LRT =',pow1lsem
        endif
        if (test2d .ne. 0.0) then
          write(6,*) 'P-value of 2D Semi est. of p Test=',pow21sem
c          write(6,*) 'P-value of 2D Semi LRT =',pow21lse
        endif
        write(6,*) 'P-value of Wilcoxon Rank Sum=',pow1wil
        write(6,*) 'P-value of Welch test=',pow1wel
        write(6,*) '----------------------------------------------'
      endif
      if (testsim .ne. 0.0) then 
        write(6,*) 'Using simulation from constrained EMLE dist.'
        write(6,*) 'P-value of ELRT=',pow2lrt
        write(6,*) 'P-value of Brunner Test=',pow2br
        if (test1d .ne. 0.0) then
          write(6,*) 'P-value of 1D Semi est. of p Test=',pow2sem
c          write(6,*) 'P-value of 1D Semi LRT =',pow2lsem
        endif
        if (test2d .ne. 0.0) then
          write(6,*) 'P-value of 2D Semi est. of p Test=',pow22sem
c          write(6,*) 'P-value of 2D Semi LRT =',pow22lse
        endif
        write(6,*) 'P-value of Wilcoxon Rank Sum=',pow2wil
        write(6,*) 'P-value of Welch test=',pow2wel
        write(6,*) '----------------------------------------------'
      endif
      write(6,*) '----------------------------------------------'
      write(6,*) 'Using Large Sample theory'
      if (testlrt .ne. 0.0) then 
        write(6,*) 'P-value of ELRT with chi^2(1) approx=',pow3lrt
      endif 
      write(6,*) 'P-value of Brunner Test=',pow3br
      if (test1d .ne. 0.0) then
c        write(6,*) 'P-value of 1D Semi Beta using Normal app.=',
c     *       pow5sem
c        write(6,*) 'P-value of 1D Semi Beta chi^2(1) app.=',pow4sem
        write(6,*) 'P-value of 1D Semi Test for p Normal app=',pow3sem
c        write(6,*) 'P-value of 1D Semi LRT with chi^2(2) app.=',
c     *       pow3lsem
      endif
      if (test2d .ne. 0.0) then
        write(6,*) 'P-value of 2D Semi Test for p Normal app=',pow23sem
c        write(6,*) 'P-value of 2D Semi LRT with chi^2(2) app.=',
c     *       pow23lse
      endif
      write(6,*) 'P-value of Wilcoxon Rank Sum using Normal app=',
     *       pow3wil
      write(6,*) 'P-value of Welch t-test with approx. dof=',pow3wel
      
      stop
      end












c
c  This subroutine calculates the p_i for given lam1
c
      subroutine pcalc(lam1,p,q)

      common data(4000),m(4000),mprime(4000),n1,n2,psum(0:4000)
      common nprime,posval(4000),lambda,lambd2
      integer m,mprime
      real lam1,p(4000),densum(10000,0:4000),pcand(10000,4000)
      real psumcand(10000,0:4000),q(4000),lambda,lambd2

c      write(6,*) '-------------------------------------------'
c      write(6,*) 'Enter PCALC'
c      write(6,*) 'lam1=',lam1
      tol=.01
      maxcand=10000
      ncand=1
      psumcand(1,0)=0.0
      densum(1,0)=0.0
      do 100 i=1,nprime
c        write(6,*) 'i=',i
        if (m(i) .eq. 0) then
          do 20 icand=1,ncand
            pcand(icand,i)=0.0 
            psumcand(icand,i)=psumcand(icand,i-1)
            theta=1.-psumcand(icand,i-1)-psumcand(icand,i)
            if (real(n2)+lam1*theta .eq. 0.0) then
c              write(6,*) 'denominator in densum is zero'
c              write(6,*) 'theta=',theta
c              write(6,*) 'm(i)=',m(i)
              densum(icand,i)=99999.
            else
              densum(icand,i)=densum(icand,i-1)+real(mprime(i))/
     *                (real(n2)+lam1*theta)
            endif
   20     continue
        else 
          if (mprime(i) .eq. 0) then
            do 30 icand=1,ncand
              densum(icand,i)=densum(icand,i-1)
              if (real(n1)+lam1*(-1.+densum(icand,i-1)+
     *             densum(icand,i)) .eq. 0.0) then
c                write(6,*) 'denominator in pcand is zero'
c                write(6,*) 'mprime(i)=',mprime(i)
                pcand(icand,i)=99999.
              else
                pcand(icand,i)=real(m(i))/
     *   (real(n1)+lam1*(-1.+densum(icand,i-1)+densum(icand,i))) 
              endif
              psumcand(icand,i)=psumcand(icand,i-1)+pcand(icand,i)
   30       continue
          else
            ncandold=ncand
            do 90 icand=1,ncandold
c    Find two candidates for p_i for given sequence up to i-1              
              a=-1.*lam1*real(n1)-lam1**2*(-1.+2*densum(icand,i-1))
              b=real(n1*n2)+lam1*real(n1)*(1.-2.*psumcand(icand,i-1))+
     *           lam1*real(mprime(i)+m(i))+lam1*
     *           (-1.+2.*densum(icand,i-1))*
     *           (real(n2)+lam1*(1.-2.*psumcand(icand,i-1)))
              c=-1.*real(m(i))*(real(n2)+lam1*(1.-2.*
     *            psumcand(icand,i-1)))
              if (a .eq. 0.0) then
                if (b .eq. 0.0) then
                    p1=-1.0
                    p2=-1.0
                  go to 33
                endif
                p1=-1.*c/b
                p2=-1.0
                go to 33
              endif
              rad=b**2-4.*a*c
              if (rad .gt. 0.0) then
                p1=(-1.*b+sqrt(rad))/(2.*a)
                p2=(-1.*b-sqrt(rad))/(2.*a)
              else
                if (rad .eq. 0.0) then
                  p1=(-1.*b)/(2.*a)
                  p2=-1.0
                else
                  p1=-1.0
                  p2=-1.0
                endif 
              endif 
   33         continue
c    Check for feasibility of candidates
              if (p1 .ge. 0.0 .and. p1 .le. 1.0) then
                if (p2 .ge. 0.0 .and. p2 .le. 1.0) then
c  p1 & p2 feasible candidates
c                  write(6,*) 'p1 and p2 feasible candidates'
                  pcand(icand,i)=p1
                  psumcand(icand,i)=psumcand(icand,i-1)+p1
                  theta=1.-psumcand(icand,i-1)-psumcand(icand,i)
                  if (real(n2)+lam1*theta .eq. 0.0) then
c                    write(6,*) 'denominator in densum is zero'
c                    write(6,*) 'theta=',theta
                    densum(icand,i)=99999.
                  else
                    densum(icand,i)=densum(icand,i-1)+real(mprime(i))/
     *                (real(n2)+lam1*theta)
                  endif 
c  Set up new candidate
                  if (ncand .eq. maxcand) then
                    write(6,*) 'Exeeded max. number of candidates'
                    go to 90
                  endif
                  ncand=ncand+1
                  do 50 j=1,i-1
                    pcand(ncand,j)=pcand(icand,j)
                    psumcand(ncand,j)=psumcand(icand,j)
                    densum(ncand,j)=densum(icand,j)
   50             continue
                  pcand(ncand,i)=p2
                  psumcand(ncand,i)=psumcand(ncand,i-1)+p2
                  theta=1.-psumcand(ncand,i-1)-psumcand(ncand,i)
                  if (real(n2)+lam1*theta .eq. 0.0) then
c                    write(6,*) 'denominator in densum is zero'
c                    write(6,*) 'theta=',theta
                    densum(icand,i)=99999.
                  else
                    densum(ncand,i)=densum(ncand,i-1)+real(mprime(i))/
     *                (real(n2)+lam1*theta)
                  endif
                else
c  p1 only feasible candidate
c                  write(6,*) 'only p1 feasible candidate'
                  pcand(icand,i)=p1
                  psumcand(icand,i)=psumcand(icand,i-1)+p1
                  theta=1.-psumcand(icand,i-1)-psumcand(icand,i)
                  if (real(n2)+lam1*theta .eq. 0.0) then
c                    write(6,*) 'denominator in densum is zero'
c                    write(6,*) 'theta=',theta
                    densum(icand,i)=99999.
                  else
                    densum(icand,i)=densum(icand,i-1)+real(mprime(i))/
     *                (real(n2)+lam1*theta)
                  endif  
                endif
              else
                if (p2 .ge. 0.0 .and. p2 .le. 1.0) then
c  p2 only feasible candidate
c                  write(6,*) 'only p2 feasible candidate'
                  pcand(icand,i)=p2
                  psumcand(icand,i)=psumcand(icand,i-1)+p2
                  theta=1.-psumcand(icand,i-1)-psumcand(icand,i)
                  if (real(n2)+lam1*theta .eq. 0.0) then
c                    write(6,*) 'denominator in densum is zero'
c                    write(6,*) 'theta=',theta
                    densum(icand,i)=99999.
                  else
                    densum(icand,i)=densum(icand,i-1)+real(mprime(i))/
     *                (real(n2)+lam1*theta)
                  endif
                else
c  No feasible candidate (Set p_i=0.0)
c                  write(6,*) 'no feasible candidate'
                  pcand(icand,i)=0.0
                  psumcand(icand,i)=psumcand(icand,i-1)
                  theta=1.-psumcand(icand,i-1)-psumcand(icand,i)
                  if (real(n2)+lam1*theta .eq. 0.0) then
c                    write(6,*) 'denominator in densum is zero'
c                    write(6,*) 'theta=',theta
                    densum(icand,i)=99999.
                  else
                    densum(icand,i)=densum(icand,i-1)+real(mprime(i))/
     *                (real(n2)+lam1*theta)
                  endif
                endif
              endif
               
   90       continue 
          endif
        endif

  100 continue
c    Check for feasibility of candidates
c      write(6,*) 'candidates'
      iselect=1
      do 200 icand=1,ncand
c        write(6,*) 'icand=',icand
c        write(6,*) 'p=',(pcand(icand,j),j=1,nprime)
c        write(6,*) 'psum=',psumcand(icand,nprime)
        flag=0.0
        qsum=0.0
        do 150 i=1,nprime
          if ((real(n2)+lam1*
     *        (1.-psumcand(icand,i-1)-psumcand(icand,i))) 
     *        .eq. 0.0) then
c            write(6,*) 'denominator for q(i) is zero'
            q(i)=9999999.
          else
            q(i)=real(mprime(i))/(real(n2)+lam1*
     *         (1.-psumcand(icand,i-1)-psumcand(icand,i)))
          endif
          if (pcand(icand,i) .gt. 1.0 .or. pcand(icand,i) .lt. 0.0)
     *       flag=1.0
          if (q(i) .gt. 1.0 .or. q(i) .lt. 0.0) flag=1.0
          qsum=qsum+q(i)
  150   continue
c        write(6,*) 'q=',(q(j),j=1,nprime)
c        write(6,*) 'qsum=',qsum
        if (flag .eq. 0.0 .and. abs(psumcand(icand,nprime)-1.) 
     *       .lt. tol .and. abs(qsum-1.) .lt. tol) then
          iselect=icand
c          write(6,*) 'Selected candidate is number',iselect
          go to 201
        endif
  200 continue
  201 continue
c  Save selected candidate
      psum(0)=0.0
      do 250 i=1,nprime
        p(i)=pcand(iselect,i)
        psum(i)=psum(i-1)+p(i) 
        if ((real(n2)+lam1*
     *       (1.-psumcand(iselect,i-1)-psumcand(iselect,i))) 
     *       .eq. 0.0) then
c          write(6,*) 'denominator for q(i) is zero'
          q(i)=9999999.
        else
          q(i)=real(mprime(i))/(real(n2)+lam1*
     *       (1.-psumcand(iselect,i-1)-psumcand(iselect,i)))
        endif
  250 continue

     
      return
      end








c
c  This subroutine calculates the score equations
c
      real function fcn(x)

      common data(4000),m(4000),mprime(4000),n1,n2,psum(0:4000)
      common nprime,posval(4000),lambda,lambd2
      integer m,mprime
      real lam1,p(4000),q(4000),lambda,lambd2

      lam1=x
      call pcalc(lam1,p,q)
c  Check feasibility of p
      flag=0.0
      qsum=0.0
      do 50 i=1,nprime
        if ((real(n2)+lam1*
     *      (1.-psum(i-1)-psum(i))) 
     *      .eq. 0.0) then
c          write(6,*) 'denominator for q(i) is zero'
          q(i)=9999999.
        else
          q(i)=real(mprime(i))/(real(n2)+lam1*
     *       (1.-psum(i-1)-psum(i)))
        endif
        if (p(i) .gt. 1.0 .or. p(i) .lt. 0.0)
     *     flag=1.0
c        if (q(i) .gt. 1.0 .or. q(i) .lt. 0.0) flag=1.0
        qsum=qsum+q(i)
   50 continue
      if (flag .eq. 1.0) then
        fcn=9999999.
c        write(6,*) 'fcn=',fcn
        return
      endif
      fcn=0.0
      do 100 i=1,nprime
        theta=1.-psum(i-1)-psum(i)
        if (real(n2)+lam1*theta .eq. 0.0) then
c          write(6,*) 'denominator in fcn is zero'
          fcn=99999.
        else
          fcn=fcn-real(mprime(i))*psum(i-1)/(real(n2)+lam1*theta)
        endif
        if (real(n2)+lam1*theta .eq. 0.0) then
c          write(6,*) 'denominator in fcn is zero'
          fcn=-99999.
        else
          fcn=fcn+real(mprime(i))*(1.-psum(i))/(real(n2)+lam1*theta)
        endif
  100 continue
c      write(6,*) 'fcn=',fcn

      return
      end







c
c  This subroutine calculates -log(likelihood)
c
c     1-DIM SEMIPARAMETRIC MODEL
c
      subroutine loglike(n,x,f)

      common data(4000),m(4000),mprime(4000),n1,n2,psum(0:4000)
      common nprime,posval(4000),lambda,lambd2
      integer m,mprime
      real lambda,lambd2
      double precision x(n),f
   
c      write(6,*) 'Entering loglike() to calculate -log(likelihood)'
c      write(6,*) 'lambda=',lambda
c      write(6,*) 'alpha=',x(1)
c      write(6,*) 'beta=',x(2)
    
      f=0.0
      do 10 i=1,n1+n2
        if (lambda .eq. 0.) then

          zz=x(1)+x(2)*log(posval(i))
          if (zz .lt. 18.42) then
            f=f+log(1.+real(n1)*exp(zz)/real(n2))
            if (i .le. n1) then
              f=f-zz
            endif
          else
            f=f+log(1.+real(n1)*exp(18.42)/real(n2))
            if (i .le. n1) then
              f=f-18.42
            endif
          endif
        else
        
          zz=x(1)+x(2)*(posval(i)**(lambda)-1.)/lambda
          if (zz .lt. 18.42) then
            f=f+log(1.+real(n1)*exp(zz)/real(n2))
            if (i .le. n1) then
              f=f-zz
            endif
          else
            f=f+log(1.+real(n1)*exp(18.42)/real(n2))
            if (i .le. n1) then
              f=f-18.42
            endif
          endif

        endif
   10 continue 

c      write(6,*) '-log(likelihood)=',f
      return
      end










c
c  This subroutine calculates -log(likelihood)
c
c     2-DIM SEMIPARAMETRIC MODEL
c
      subroutine log2like(n,x,f)

      common data(4000),m(4000),mprime(4000),n1,n2,psum(0:4000)
      common nprime,posval(4000),lambda,lambd2
      integer m,mprime
      real lambda,lambd2
      double precision x(n),f
   
c      write(6,*) 'Entering loglike() to calculate -log(likelihood)'
c      write(6,*) 'lambda=',lambda
c      write(6,*) 'lambda2=',lambd2
c      write(6,*) 'alpha=',x(1)
c      write(6,*) 'beta1=',x(2)
c      write(6,*) 'beta2=',x(3)
    
      f=0.0
      do 10 i=1,n1+n2
        if (lamda .eq. 0. .and. lambd2 .eq. 0.) then

          zz=x(1)+x(2)*log(posval(i))
     *           +x(3)*log(posval(i))

        else

          if (lambda .eq. 0.) then

            zz=x(1)+x(2)*log(posval(i))
     *           +x(3)*(posval(i)**(lambd2)-1.)/lambd2

          else

            if (lambd2 .eq. 0.) then
              zz=x(1)+x(2)*(posval(i)**(lambda)-1.)/lambda
     *           +x(3)*log(posval(i))

            else

              zz=x(1)+x(2)*(posval(i)**(lambda)-1.)/lambda
     *           +x(3)*(posval(i)**(lambd2)-1.)/lambd2

            endif
          endif
        endif

c        write(6,*) 'i=',i
c        write(6,*) 'theta_i=',zz
        if (zz .lt. 18.42) then
          f=f+log(1.+real(n1)*exp(zz)/real(n2))
          if (i .le. n1) then
            f=f-zz
          endif
        else
          f=f+log(1.+real(n1)*exp(18.42)/real(n2))
          if (i .le. n1) then
            f=f-18.42
          endif
        endif
   10 continue 

c      write(6,*) '-log(likelihood)=',f
      return
      end













c
c  This subroutine calculates the gradient to -log(likelihood)
c
c     1-DIM SEMIPARAMETRIC MODEL
c
      subroutine grad(n,x,g)

      common data(4000),m(4000),mprime(4000),n1,n2,psum(0:4000)
      common nprime,posval(4000),lambda,lambd2
      integer m,mprime
      real lambda,lambd2
      double precision x(n),g(n)
  
c      write(6,*) 'Entering grad() to find gradient to -log(likelihood)'
c      write(6,*) 'lambda=',lambda
c      write(6,*) 'alpha=',x(1)
c      write(6,*) 'beta=',x(2)

      g(1)=-1.*real(n1)
      g(2)=0.0
      do 10 i=1,n1+n2
        if (lambda .eq. 0.) then

        if (x(1)+x(2)*log(posval(i)) .lt. 18.42) then
          zz=exp(x(1)+x(2)*log(posval(i)))
        else
          zz=exp(18.42)
        endif

        g(1)=g(1)+real(n1)*zz
     *       /(real(n2)+real(n1)*zz) 

        g(2)=g(2)+real(n1)*zz*log(posval(i))
     *       /(real(n2)+real(n1)*zz)
        if (i .le. n1) then
          g(2)=g(2)-log(posval(i))
        endif

        else

          if (x(1)+x(2)*(posval(i)**(lambda)-1.)/lambda
     *         .lt. 18.42)
     *    then
            zz=exp(x(1)+x(2)*(posval(i)**(lambda)-1.)/lambda)
          else
            zz=exp(18.42)
          endif

          g(1)=g(1)+real(n1)*zz
     *         /(real(n2)+real(n1)*zz) 

          g(2)=g(2)+real(n1)*zz*(posval(i)**(lambda)-1.)
     *         /(lambda*(real(n2)+real(n1)*zz))
          if (i .le. n1) then
            g(2)=g(2)-(posval(i)**(lambda)-1.)/lambda
          endif
  
        endif
   10 continue 

c      write(6,*) 'gradient=',(g(i),i=1,2)
      return
      end











c
c  This subroutine calculates the gradient to -log(likelihood)
c
c     2-DIM SEMIPARAMETRIC MODEL
c
      subroutine grad2(n,x,g)

      common data(4000),m(4000),mprime(4000),n1,n2,psum(0:4000)
      common nprime,posval(4000),lambda,lambd2
      integer m,mprime
      real lambda,lambd2
      double precision x(n),g(n)
  
c      write(6,*) 'Entering grad() to find gradient to -log(likelihood)'
c      write(6,*) 'lambda1=',lambda
c      write(6,*) 'lambda2=',lambd2
c      write(6,*) 'alpha=',x(1)
c      write(6,*) 'beta1=',x(2)
c      write(6,*) 'beta2=',x(3)

      g(1)=-1.*real(n1)
      g(2)=0.0
      g(3)=0.0
      do 10 i=1,n1+n2
        if (lambda .eq. 0. .and. lambd2 .eq. 0) then

          z=x(1)+x(2)*log(posval(i))
     *          +x(3)*log(posval(i))
          if (z .lt. 18.42) then
            zz=exp(z)
          else
            zz=exp(18.42)
          endif

          g(1)=g(1)+real(n1)*zz
     *         /(real(n2)+real(n1)*zz) 

          g(2)=g(2)+real(n1)*zz*log(posval(i))
     *         /(real(n2)+real(n1)*zz)
          if (i .le. n1) then
            g(2)=g(2)-log(posval(i))
          endif
          g(3)=g(3)+real(n1)*zz*log(posval(i))
     *         /(real(n2)+real(n1)*zz)
          if (i .le. n1) then
            g(3)=g(3)-log(posval(i))
          endif
        else

          if (lambda .eq. 0.) then

            z=x(1)+x(2)*log(posval(i))
     *          +x(3)*(posval(i)**(lambd2)-1.)/lambd2
            if (z .lt. 18.42) then
              zz=exp(z)
            else
              zz=exp(18.42)
            endif

            g(1)=g(1)+real(n1)*zz
     *           /(real(n2)+real(n1)*zz) 

            g(2)=g(2)+real(n1)*zz*log(posval(i))
     *           /(real(n2)+real(n1)*zz)
            if (i .le. n1) then
              g(2)=g(2)-log(posval(i))
            endif
            g(3)=g(3)+real(n1)*zz*(posval(i)**(lambd2)-1.)
     *           /(lambd2*(real(n2)+real(n1)*zz))
            if (i .le. n1) then
              g(3)=g(3)-(posval(i)**(lambd2)-1.)/lambd2
            endif

          else
            if (lambd2 .eq. 0.) then

              z=x(1)+x(2)*(posval(i)**(lambda)-1.)/lambda
     *              +x(3)*log(posval(i))
              if (z .lt. 18.42) then
                zz=exp(z)
              else
                zz=exp(18.42)
              endif

              g(1)=g(1)+real(n1)*zz
     *             /(real(n2)+real(n1)*zz) 

              g(2)=g(2)+real(n1)*zz*(posval(i)**(lambda)-1.)
     *             /(lambda*(real(n2)+real(n1)*zz))
              if (i .le. n1) then
                g(2)=g(2)-(posval(i)**(lambda)-1.)/lambda
              endif
              g(3)=g(3)+real(n1)*zz*log(posval(i))
     *             /(real(n2)+real(n1)*zz)
              if (i .le. n1) then
                g(3)=g(3)-log(posval(i))
              endif

            else
              z=x(1)+x(2)*(posval(i)**(lambda)-1.)/lambda
     *              +x(3)*(posval(i)**(lambd2)-1.)/lambd2
              if (z .lt. 18.42) then
                zz=exp(z)
              else
                zz=exp(18.42)
              endif

              g(1)=g(1)+real(n1)*zz
     *             /(real(n2)+real(n1)*zz) 

              g(2)=g(2)+real(n1)*zz*(posval(i)**(lambda)-1.)
     *             /(lambda*(real(n2)+real(n1)*zz))
              if (i .le. n1) then
                g(2)=g(2)-(posval(i)**(lambda)-1.)/lambda
              endif
              g(3)=g(3)+real(n1)*zz*(posval(i)**(lambd2)-1.)
     *             /(lambd2*(real(n2)+real(n1)*zz))
              if (i .le. n1) then
                g(3)=g(3)-(posval(i)**(lambd2)-1.)/lambd2
              endif
            endif

          endif
        endif
   10 continue 

c      write(6,*) 'gradient=',(g(i),i=1,3)
      return
      end
